/**
 * lwipopts.h - user/system specific lwIP configuration
 * (c) 2015-2019 Roman Bartosinski
 *
 * Changelog:
 * - 2015 - initial version (release 1.4.0)
 * - 2019 - update to LWIP release 2.1.2
 *        - removed:
 *          MEMP_SEPARATE_POOLS, MEMP_NUM_SNMP_NODE, MEMP_NUM_SNMP_ROOTNODE,
 *          MEMP_NUM_SNMP_VARBIND, MEMP_NUM_SNMP_VALUE, ETHARP_TRUST_IP_MAC
 *          SNMP_CONCURRENT_REQUESTS, SNMP_PRIVATE_MIB, SNMP_MAX_TREE_DEPTH
 *          SNMP_COMMUNITY_EXT, SNMP_MSG_DEBUG
 *          IP_FRAG_USES_STATIC_BUF, IP_FRAG_MAX_MTU, LWIP_RANDOMIZE_INITIAL_LOCAL_PORTS
 *          LWIP_DHCP_CHECK_LINK_UP, LWIP_HAVE_SLIPIF, LWIP_SOCKET_SET_ERRNO
 *        - added OMK specific:
 *          LWIP_APP_MQTT, LWIP_APP_TFTP, LWIP_APP_SNTP ,LWIP_APP_SMTP,
 *          LWIP_APP_NETBIOSNS, LWIP_APP_HTTPC, LWIP_APP_HTTPD, LWIP_APP_IPERF
 *        - added:
 *          LWIP_TIMERS_CUSTOM, LWIP_ASSERT_CORE_LOCKED, LWIP_MARK_TCPIP_THREAD,
 *          MEMMOVE, MEMP_MEM_INIT, MEM_OVERFLOW_CHECK, MEM_SANITY_CHECK,
 *          MEMP_NUM_ALTCP_PCB, MEMP_NUM_SELECT_CB,
 *          ARP_MAXAGE, LWIP_MIB2_CALLBACKS, LWIP_PBUF_REF_T,
 *          LWIP_DHCP_MAX_DNS_SERVERS, LWIP_DNS_SECURE,
 *          LWIP_TCP_PCB_NUM_EXT_ARGS, LWIP_ALTCP, LWIP_ALTCP_TLS,
 *          MIB2_STATS, LWIP_CHECKSUM_CTRL_PER_NETIF, LWIP_SINGLE_NETIF,
 *          DNS_MAX_RETRIES, LWIP_DNS_SUPPORT_MDNS_QUERIES,
 *          LWIP_TCP_SACK_OUT, LWIP_TCP_MAX_SACK_NUM,
 *          DHCP6_DEBUG, LWIP_TESTMODE, IPV6_REASS_MAXAGE,
 *          LWIP_IPV6_SCOPES, LWIP_IPV6_SCOPES_DEBUG, LWIP_IPV6_ADDRESS_LIFETIMES,
 *          LWIP_ND6_RDNSS_MAX_DNS_SERVERS, LWIP_IPV6_DHCP6_STATEFUL,
 *          LWIP_IPV6_DHCP6_STATELESS, LWIP_DHCP6_GET_NTP_SRV,
 *          LWIP_DHCP6_MAX_NTP_SERVERS, LWIP_DHCP6_MAX_DNS_SERVERS,
 *          LWIP_NUM_NETIF_CLIENT_DATA, LWIP_LOOPIF_MULTICAST,
 *          LWIP_NETIF_EXT_STATUS_CALLBACK, LWIP_TCPIP_THREAD_ALIVE,
 *          LWIP_SOCKET_SELECT, LWIP_SOCKET_POLL
 *        - added all Hook options:
 *          LWIP_HOOK_FILENAME, LWIP_HOOK_TCP_ISN, LWIP_HOOK_TCP_INPACKET_PCB,
 *          LWIP_HOOK_TCP_OUT_TCPOPT_LENGTH, LWIP_HOOK_TCP_OUT_ADD_TCPOPTS,
 *          LWIP_HOOK_IP4_INPUT, LWIP_HOOK_IP4_ROUTE, LWIP_HOOK_IP4_ROUTE_SRC,
 *          LWIP_HOOK_IP4_CANFORWARD, LWIP_HOOK_ETHARP_GET_GW,
 *          LWIP_HOOK_IP6_INPUT, LWIP_HOOK_IP6_ROUTE, LWIP_HOOK_ND6_GET_GW,
 *          LWIP_HOOK_VLAN_CHECK, LWIP_HOOK_VLAN_SET, LWIP_HOOK_MEMP_AVAILABLE,
 *          LWIP_HOOK_UNKNOWN_ETH_PROTOCOL, LWIP_HOOK_DHCP_APPEND_OPTIONS,
 *          LWIP_HOOK_DHCP_PARSE_OPTION, LWIP_HOOK_DHCP6_APPEND_OPTIONS,
 *          LWIP_HOOK_SOCKETS_SETSOCKOPT, LWIP_HOOK_SOCKETS_GETSOCKOPT,
 *          LWIP_HOOK_NETCONN_EXTERNAL_RESOLVE(name, addr, addrtype, err)
 *        - added to PPP:
 *          PPP_NUM_TIMEOUTS_PER_PCB, PPP_NUM_TIMEOUTS, MEMP_NUM_PPP_API_MSG,
 *          LWIP_USE_EXTERNAL_POLARSSL, LWIP_USE_EXTERNAL_MBEDTLS
 *        - added MQTT application:
 *          MQTT_OUTPUT_RINGBUF_SIZE, MQTT_VAR_HEADER_BUFFER_LEN, MQTT_REQ_MAX_IN_FLIGHT,
 *          MQTT_CYCLIC_TIMER_INTERVAL, MQTT_REQ_TIMEOUT, MQTT_CONNECT_TIMOUT
 *        - added TFTP server:
 *          TFTP_DEBUG, TFTP_PORT, TFTP_TIMEOUT_MSECS, TFTP_MAX_RETRIES,
 *          TFTP_TIMER_MSECS, TFTP_MAX_FILENAME_LEN, TFTP_MAX_MODE_LEN
 *        - added MDNS module:
 *          LWIP_MDNS_RESPONDER, MDNS_MAX_SERVICES,
 *          MDNS_RESP_USENETIF_EXTCALLBACK, MDNS_DEBUG
 *        - added SNTP client:
 *          SNTP_SET_SYSTEM_TIME, SNTP_MAX_SERVERS, SNTP_GET_SERVERS_FROM_DHCP,
 *          SNTP_SERVER_ADDRESS, SNTP_SERVER_DNS, SNTP_DEBUG,
 *          SNTP_PORT, SNTP_CHECK_RESPONSE, SNTP_COMP_ROUNDTRIP, SNTP_STARTUP_DELAY,
 *          SNTP_STARTUP_DELAY, SNTP_STARTUP_DELAY_FUNC, SNTP_RECV_TIMEOUT,
 *          SNTP_UPDATE_DELAY, SNTP_GET_SYSTEM_TIME, SNTP_RETRY_TIMEOUT,
 *          SNTP_RETRY_TIMEOUT_MAX, SNTP_RETRY_TIMEOUT_EXP, SNTP_MONITOR_SERVER_REACHABILITY
 *        - added for ALTCP:
 *          LWIP_ALTCP_TLS_MBEDTLS, ALTCP_MBEDTLS_DEBUG,
 *          ALTCP_MBEDTLS_SESSION_CACHE_TIMEOUT_SECONDS
 *        - added for SMTP client module:
 *          SMTP_BODYDH, SMTP_DEBUG, SMTP_MAX_SERVERNAME_LEN, SMTP_MAX_USERNAME_LEN,
 *          SMTP_MAX_PASS_LEN, SMTP_COPY_AUTHDATA, SMTP_CHECK_DATA, SMTP_SUPPORT_AUTH_PLAIN,
 *          SMTP_SUPPORT_AUTH_LOGIN, SMTP_STATE_MALLOC, SMTP_STATE_FREE
 *        - added NetBIOS name service responder
 *          NETBIOS_LWIP_NAME, LWIP_NETBIOS_RESPOND_NAME_QUERY
 *        - added SNMP server:
 *          SNMP_USE_NETCONN, SNMP_USE_RAW, SNMP_STACK_SIZE, SNMP_THREAD_PRIO,
 *          SNMP_MAX_OBJ_ID_LEN, SNMP_MIN_VALUE_SIZE, SNMP_MAX_COMMUNITY_STR_LEN,
 *          SNMP_LWIP_ENTERPRISE_OID, SNMP_DEVICE_ENTERPRISE_OID,
 *          SNMP_DEVICE_ENTERPRISE_OID_LEN, SNMP_DEBUG, SNMP_LWIP_MIB2,
 *          SNMP_LWIP_MIB2_SYSDESC, SNMP_LWIP_MIB2_SYSNAME, SNMP_LWIP_MIB2_SYSCONTACT,
 *          SNMP_LWIP_MIB2_SYSLOCATION, SNMP_LWIP_GETBULK_MAX_REPETITIONS,
 *          LWIP_SNMP_V3, LWIP_SNMP_V3_MBEDTLS, LWIP_SNMP_V3_CRYPTO,
 *          LWIP_SNMP_CONFIGURE_VERSIONS,
 *        - added HTTP server:
 *          LWIP_HTTPD_CGI, LWIP_HTTPD_CGI_SSI, LWIP_HTTPD_SSI, LWIP_HTTPD_SSI_RAW,
 *          LWIP_HTTPD_SSI_BY_FILE_EXTENSION, LWIP_HTTPD_SUPPORT_POST,
 *          LWIP_HTTPD_MAX_CGI_PARAMETERS, LWIP_HTTPD_SSI_MULTIPART,
 *          LWIP_HTTPD_MAX_TAG_NAME_LEN, LWIP_HTTPD_MAX_TAG_INSERT_LEN,
 *          LWIP_HTTPD_POST_MANUAL_WND, HTTPD_SERVER_AGENT, LWIP_HTTPD_DYNAMIC_HEADERS,
 *          HTTPD_DEBUG, HTTPD_USE_MEM_POOL, HTTPD_SERVER_PORT, HTTPD_SERVER_PORT_HTTPS,
 *          HTTPD_ENABLE_HTTPS, HTTPD_MAX_RETRIES, HTTPD_POLL_INTERVAL, HTTPD_TCP_PRIO,
 *          LWIP_HTTPD_TIMING, HTTPD_DEBUG_TIMING, LWIP_HTTPD_SUPPORT_EXTSTATUS,
 *          LWIP_HTTPD_SUPPORT_V09, LWIP_HTTPD_SUPPORT_11_KEEPALIVE,
 *          LWIP_HTTPD_SUPPORT_REQUESTLIST, LWIP_HTTPD_REQ_QUEUELEN,
 *          LWIP_HTTPD_REQ_BUFSIZE, LWIP_HTTPD_MAX_REQ_LENGTH, LWIP_HTTPD_MAX_REQUEST_URI_LEN,
 *          LWIP_HTTPD_POST_MAX_RESPONSE_URI_LEN, LWIP_HTTPD_SSI_INCLUDE_TAG,
 *          LWIP_HTTPD_ABORT_ON_CLOSE_MEM_ERROR, LWIP_HTTPD_KILL_OLD_ON_CONNECTIONS_EXCEEDED,
 *          LWIP_HTTPD_OMIT_HEADER_FOR_EXTENSIONLESS_URI, HTTP_IS_TAG_VOLATILE,
 *          HTTPD_LIMIT_SENDING_TO_2MSS, HTTPD_MAX_WRITE_LEN, LWIP_HTTPD_CUSTOM_FILES,
 *          LWIP_HTTPD_DYNAMIC_FILE_READ, LWIP_HTTPD_FILE_STATE, HTTPD_PRECALCULATED_CHECKSUM,
 *          LWIP_HTTPD_FS_ASYNC_READ, HTTPD_FSDATA_FILE
 *
 *        - deprecated:
 *          NO_SYS_NO_TIMERS
 *
 *        - not added: options from  netif/bridgeif_opts.h, netif/lowpan6_opts.h
 */

#ifndef LWIPOPTS_CONNECTION_TO_OMK_CONFIGURATION_HEADER_FILE
#define LWIPOPTS_CONNECTION_TO_OMK_CONFIGURATION_HEADER_FILE

/* read options from configuration generated by OMK */
#include "lwipconfig.h"

/* Use options configured in OMK otherwise use default values from
 * lwip/opt.h,
 * netif/ppp/ppp_opts.h, netif/bridgeif_opts.h, netif/lowpan6_opts.h,
 * lwip/apps/altcp_tls_mbedtls_opts.h, lwip/apps/httpd_opts.h,
 * lwip/apps/mdns_opts.h, lwip/apps/mqtt_opts.h, lwip/apps/netbiosns_opts.h,
 * lwip/apps/smtp_opts.h, lwip/apps/snmp_opts.h, lwip/apps/sntp_opts.h,
 * lwip/apps/tftp_opts.h
 */

/***   Platform specific locking   ***/
#ifdef CONFIG_LWIP_NO_SYS
  #define NO_SYS CONFIG_LWIP_NO_SYS
#endif
#ifdef CONFIG_LWIP_NO_SYS_NO_TIMERS
  #define NO_SYS_NO_TIMERS CONFIG_LWIP_NO_SYS_NO_TIMERS
#endif
#ifdef CONFIG_LWIP_LWIP_TIMERS_CUSTOM
  #define LWIP_TIMERS_CUSTOM CONFIG_LWIP_LWIP_TIMERS_CUSTOM
#endif
#ifdef CONFIG_LWIP_MEMCPY
  #define MEMCPY CONFIG_LWIP_MEMCPY
#endif
#ifdef CONFIG_LWIP_SMEMCPY
  #define SMEMCPY CONFIG_LWIP_SMEMCPY
#endif
#ifdef CONFIG_LWIP_MEMMOVE
  #define MEMMOVE CONFIG_LWIP_MEMMOVE
#endif
#ifdef CONFIG_LWIP_LWIP_MPU_COMPATIBLE
  #define LWIP_MPU_COMPATIBLE CONFIG_LWIP_LWIP_MPU_COMPATIBLE
#endif
#ifdef CONFIG_LWIP_LWIP_TCPIP_CORE_LOCKING
  #define LWIP_TCPIP_CORE_LOCKING CONFIG_LWIP_LWIP_TCPIP_CORE_LOCKING
#endif
#ifdef CONFIG_LWIP_LWIP_TCPIP_CORE_LOCKING_INPUT
  #define LWIP_TCPIP_CORE_LOCKING_INPUT CONFIG_LWIP_LWIP_TCPIP_CORE_LOCKING_INPUT
#endif
#ifdef CONFIG_LWIP_SYS_LIGHTWEIGHT_PROT
  #define SYS_LIGHTWEIGHT_PROT CONFIG_LWIP_SYS_LIGHTWEIGHT_PROT
#endif
#ifdef CONFIG_LWIP_LWIP_ASSERT_CORE_LOCKED
  #define LWIP_ASSERT_CORE_LOCKED CONFIG_LWIP_LWIP_ASSERT_CORE_LOCKED
#endif
#ifdef CONFIG_LWIP_LWIP_MARK_TCPIP_THREAD
  #define LWIP_MARK_TCPIP_THREAD CONFIG_LWIP_LWIP_MARK_TCPIP_THREAD
#endif
/***   Memory options   ***/
#ifdef CONFIG_LWIP_MEM_LIBC_MALLOC
  #define MEM_LIBC_MALLOC CONFIG_LWIP_MEM_LIBC_MALLOC
#endif
#ifdef CONFIG_LWIP_MEMP_MEM_MALLOC
  #define MEMP_MEM_MALLOC CONFIG_LWIP_MEMP_MEM_MALLOC
#endif
#ifdef CONFIG_LWIP_MEMP_MEM_INIT
  #define MEMP_MEM_INIT CONFIG_LWIP_MEMP_MEM_INIT
#endif
#ifdef CONFIG_LWIP_MEM_ALIGNMENT
  #define MEM_ALIGNMENT CONFIG_LWIP_MEM_ALIGNMENT
#endif
#ifdef CONFIG_LWIP_MEM_SIZE
  #define MEM_SIZE CONFIG_LWIP_MEM_SIZE
#endif

#ifdef CONFIG_LWIP_MEMP_OVERFLOW_CHECK
  #define MEMP_OVERFLOW_CHECK CONFIG_LWIP_MEMP_OVERFLOW_CHECK
#endif
#ifdef CONFIG_LWIP_MEMP_SANITY_CHECK
  #define MEMP_SANITY_CHECK CONFIG_LWIP_MEMP_SANITY_CHECK
#endif
#ifdef CONFIG_LWIP_MEM_OVERFLOW_CHECK
  #define MEM_OVERFLOW_CHECK CONFIG_LWIP_MEM_OVERFLOW_CHECK
#endif
#ifdef CONFIG_LWIP_MEM_SANITY_CHECK
  #define MEM_SANITY_CHECK CONFIG_LWIP_MEM_SANITY_CHECK
#endif


#ifdef CONFIG_LWIP_MEM_USE_POOLS
  #define MEM_USE_POOLS CONFIG_LWIP_MEM_USE_POOLS
#endif
#ifdef CONFIG_LWIP_MEM_USE_POOLS_TRY_BIGGER_POOL
  #define MEM_USE_POOLS_TRY_BIGGER_POOL CONFIG_LWIP_MEM_USE_POOLS_TRY_BIGGER_POOL
#endif
#ifdef CONFIG_LWIP_MEMP_USE_CUSTOM_POOLS
  #define MEMP_USE_CUSTOM_POOLS CONFIG_LWIP_MEMP_USE_CUSTOM_POOLS
#endif
#ifdef CONFIG_LWIP_LWIP_ALLOW_MEM_FREE_FROM_OTHER_CONTEXT
  #define LWIP_ALLOW_MEM_FREE_FROM_OTHER_CONTEXT CONFIG_LWIP_LWIP_ALLOW_MEM_FREE_FROM_OTHER_CONTEXT
#endif

/***   Internal Memory Pool Sizes   ***/
#ifdef CONFIG_LWIP_MEMP_NUM_PBUF
  #define MEMP_NUM_PBUF CONFIG_LWIP_MEMP_NUM_PBUF
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_RAW_PCB
  #define MEMP_NUM_RAW_PCB CONFIG_LWIP_MEMP_NUM_RAW_PCB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_UDP_PCB
  #define MEMP_NUM_UDP_PCB CONFIG_LWIP_MEMP_NUM_UDP_PCB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_TCP_PCB
  #define MEMP_NUM_TCP_PCB CONFIG_LWIP_MEMP_NUM_TCP_PCB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_TCP_PCB_LISTEN
  #define MEMP_NUM_TCP_PCB_LISTEN CONFIG_LWIP_MEMP_NUM_TCP_PCB_LISTEN
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_TCP_SEG
  #define MEMP_NUM_TCP_SEG CONFIG_LWIP_MEMP_NUM_TCP_SEG
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_ALTCP_PCB
  #define MEMP_NUM_ALTCP_PCB CONFIG_LWIP_MEMP_NUM_ALTCP_PCB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_REASSDATA
  #define MEMP_NUM_REASSDATA CONFIG_LWIP_MEMP_NUM_REASSDATA
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_FRAG_PBUF
  #define MEMP_NUM_FRAG_PBUF CONFIG_LWIP_MEMP_NUM_FRAG_PBUF
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_ARP_QUEUE
  #define MEMP_NUM_ARP_QUEUE CONFIG_LWIP_MEMP_NUM_ARP_QUEUE
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_IGMP_GROUP
  #define MEMP_NUM_IGMP_GROUP CONFIG_LWIP_MEMP_NUM_IGMP_GROUP
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_SYS_TIMEOUT
  #define MEMP_NUM_SYS_TIMEOUT CONFIG_LWIP_MEMP_NUM_SYS_TIMEOUT
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_NETBUF
  #define MEMP_NUM_NETBUF CONFIG_LWIP_MEMP_NUM_NETBUF
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_NETCONN
  #define MEMP_NUM_NETCONN CONFIG_LWIP_MEMP_NUM_NETCONN
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_SELECT_CB
  #define MEMP_NUM_SELECT_CB CONFIG_LWIP_MEMP_NUM_SELECT_CB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_TCPIP_MSG_API
  #define MEMP_NUM_TCPIP_MSG_API CONFIG_LWIP_MEMP_NUM_TCPIP_MSG_API
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_TCPIP_MSG_INPKT
  #define MEMP_NUM_TCPIP_MSG_INPKT CONFIG_LWIP_MEMP_NUM_TCPIP_MSG_INPKT
#endif

#ifdef CONFIG_LWIP_MEMP_NUM_NETDB
  #define MEMP_NUM_NETDB CONFIG_LWIP_MEMP_NUM_NETDB
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_LOCALHOSTLIST
  #define MEMP_NUM_LOCALHOSTLIST CONFIG_LWIP_MEMP_NUM_LOCALHOSTLIST
#endif

#ifdef CONFIG_LWIP_PBUF_POOL_SIZE
  #define PBUF_POOL_SIZE CONFIG_LWIP_PBUF_POOL_SIZE
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_API_MSG
  #define MEMP_NUM_API_MSG CONFIG_LWIP_MEMP_NUM_API_MSG
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_DNS_API_MSG
  #define MEMP_NUM_DNS_API_MSG CONFIG_LWIP_MEMP_NUM_DNS_API_MSG
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_SOCKET_SETGETSOCKOPT_DATA
  #define MEMP_NUM_SOCKET_SETGETSOCKOPT_DATA CONFIG_LWIP_MEMP_NUM_SOCKET_SETGETSOCKOPT_DATA
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_NETIFAPI_MSG
  #define MEMP_NUM_NETIFAPI_MSG CONFIG_LWIP_MEMP_NUM_NETIFAPI_MSG
#endif

/***   ARP options   ***/
#ifdef CONFIG_LWIP_LWIP_ARP
  #define LWIP_ARP CONFIG_LWIP_LWIP_ARP
#endif
#ifdef CONFIG_LWIP_ARP_TABLE_SIZE
  #define ARP_TABLE_SIZE CONFIG_LWIP_ARP_TABLE_SIZE
#endif
#ifdef CONFIG_LWIP_ARP_MAXAGE
  #define ARP_MAXAGE CONFIG_LWIP_ARP_MAXAGE
#endif
#ifdef CONFIG_LWIP_ARP_QUEUEING
  #define ARP_QUEUEING CONFIG_LWIP_ARP_QUEUEING
#endif
#ifdef CONFIG_LWIP_ARP_QUEUE_LEN
  #define ARP_QUEUE_LEN CONFIG_LWIP_ARP_QUEUE_LEN
#endif

#ifdef CONFIG_LWIP_ETHARP_SUPPORT_VLAN
  #define ETHARP_SUPPORT_VLAN CONFIG_LWIP_ETHARP_SUPPORT_VLAN
#endif
#ifdef CONFIG_LWIP_LWIP_ETHERNET
  #define LWIP_ETHERNET CONFIG_LWIP_LWIP_ETHERNET
#endif
#ifdef CONFIG_LWIP_ETH_PAD_SIZE
  #define ETH_PAD_SIZE CONFIG_LWIP_ETH_PAD_SIZE
#endif
#ifdef CONFIG_LWIP_ETHARP_SUPPORT_STATIC_ENTRIES
  #define ETHARP_SUPPORT_STATIC_ENTRIES CONFIG_LWIP_ETHARP_SUPPORT_STATIC_ENTRIES
#endif
#ifdef CONFIG_LWIP_ETHARP_TABLE_MATCH_NETIF
  #define ETHARP_TABLE_MATCH_NETIF CONFIG_LWIP_ETHARP_TABLE_MATCH_NETIF
#endif

/***   IP options   ***/
#ifdef CONFIG_LWIP_LWIP_IPV4
  #define LWIP_IPV4 CONFIG_LWIP_LWIP_IPV4
#endif
#ifdef CONFIG_LWIP_IP_FORWARD
  #define IP_FORWARD CONFIG_LWIP_IP_FORWARD
#endif
#ifdef CONFIG_LWIP_IP_REASSEMBLY
  #define IP_REASSEMBLY CONFIG_LWIP_IP_REASSEMBLY
#endif
#ifdef CONFIG_LWIP_IP_FRAG
  #define IP_FRAG CONFIG_LWIP_IP_FRAG
#endif
#ifdef CONFIG_LWIP_IP_OPTIONS_ALLOWED
  #define IP_OPTIONS_ALLOWED CONFIG_LWIP_IP_OPTIONS_ALLOWED
#endif
#ifdef CONFIG_LWIP_IP_REASS_MAXAGE
  #define IP_REASS_MAXAGE CONFIG_LWIP_IP_REASS_MAXAGE
#endif
#ifdef CONFIG_LWIP_IP_REASS_MAX_PBUFS
  #define IP_REASS_MAX_PBUFS CONFIG_LWIP_IP_REASS_MAX_PBUFS
#endif
#ifdef CONFIG_LWIP_IP_DEFAULT_TTL
  #define IP_DEFAULT_TTL CONFIG_LWIP_IP_DEFAULT_TTL
#endif
#ifdef CONFIG_LWIP_IP_SOF_BROADCAST
  #define IP_SOF_BROADCAST CONFIG_LWIP_IP_SOF_BROADCAST
#endif
#ifdef CONFIG_LWIP_IP_SOF_BROADCAST_RECV
  #define IP_SOF_BROADCAST_RECV CONFIG_LWIP_IP_SOF_BROADCAST_RECV
#endif
#ifdef CONFIG_LWIP_IP_FORWARD_ALLOW_TX_ON_RX_NETIF
  #define IP_FORWARD_ALLOW_TX_ON_RX_NETIF CONFIG_LWIP_IP_FORWARD_ALLOW_TX_ON_RX_NETIF
#endif

/***   ICMP options   ***/
#ifdef CONFIG_LWIP_LWIP_ICMP
  #define LWIP_ICMP CONFIG_LWIP_LWIP_ICMP
#endif
#ifdef CONFIG_LWIP_ICMP_TTL
  #define ICMP_TTL CONFIG_LWIP_ICMP_TTL
#endif
#ifdef CONFIG_LWIP_LWIP_BROADCAST_PING
  #define LWIP_BROADCAST_PING CONFIG_LWIP_LWIP_BROADCAST_PING
#endif
#ifdef CONFIG_LWIP_LWIP_MULTICAST_PING
  #define LWIP_MULTICAST_PING CONFIG_LWIP_LWIP_MULTICAST_PING
#endif


/***   RAW options   ***/
#ifdef CONFIG_LWIP_LWIP_RAW
  #define LWIP_RAW CONFIG_LWIP_LWIP_RAW
#endif
#ifdef CONFIG_LWIP_RAW_TTL
  #define RAW_TTL CONFIG_LWIP_RAW_TTL
#endif

/***   DHCP options   ***/
#ifdef CONFIG_LWIP_LWIP_DHCP
  #define LWIP_DHCP CONFIG_LWIP_LWIP_DHCP
#endif
#ifdef CONFIG_LWIP_DHCP_DOES_ARP_CHECK
  #define DHCP_DOES_ARP_CHECK CONFIG_LWIP_DHCP_DOES_ARP_CHECK
#endif

#ifdef CONFIG_LWIP_LWIP_DHCP_BOOTP_FILE
  #define LWIP_DHCP_BOOTP_FILE CONFIG_LWIP_LWIP_DHCP_BOOTP_FILE
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP_GET_NTP_SRV
  #define LWIP_DHCP_GET_NTP_SRV CONFIG_LWIP_LWIP_DHCP_GET_NTP_SRV
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP_MAX_NTP_SERVERS
  #define LWIP_DHCP_MAX_NTP_SERVERS CONFIG_LWIP_LWIP_DHCP_MAX_NTP_SERVERS
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP_MAX_DNS_SERVERS
  #define LWIP_DHCP_MAX_DNS_SERVERS CONFIG_LWIP_LWIP_DHCP_MAX_DNS_SERVERS
#endif


/***   AUTOIP options   ***/
#ifdef CONFIG_LWIP_LWIP_AUTOIP
  #define LWIP_AUTOIP CONFIG_LWIP_LWIP_AUTOIP
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP_AUTOIP_COOP
  #define LWIP_DHCP_AUTOIP_COOP CONFIG_LWIP_LWIP_DHCP_AUTOIP_COOP
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP_AUTOIP_COOP_TRIES
  #define LWIP_DHCP_AUTOIP_COOP_TRIES CONFIG_LWIP_LWIP_DHCP_AUTOIP_COOP_TRIES
#endif
/***   SNMP MIB2 support   ***/
#ifdef CONFIG_LWIP_LWIP_MIB2_CALLBACKS
 #define LWIP_MIB2_CALLBACKS CONFIG_LWIP_LWIP_MIB2_CALLBACKS
#endif

/***   Multicast/IGMP options   ***/
#ifdef CONFIG_LWIP_LWIP_IGMP
  #define LWIP_IGMP CONFIG_LWIP_LWIP_IGMP
#endif
#ifdef CONFIG_LWIP_LWIP_MULTICAST_TX_OPTIONS
  #define LWIP_MULTICAST_TX_OPTIONS CONFIG_LWIP_LWIP_MULTICAST_TX_OPTIONS
#endif

/***   DNS options   ***/
#ifdef CONFIG_LWIP_LWIP_DNS
  #define LWIP_DNS CONFIG_LWIP_LWIP_DNS
#endif
#ifdef CONFIG_LWIP_DNS_TABLE_SIZE
  #define DNS_TABLE_SIZE CONFIG_LWIP_DNS_TABLE_SIZE
#endif
#ifdef CONFIG_LWIP_DNS_MAX_NAME_LENGTH
  #define DNS_MAX_NAME_LENGTH CONFIG_LWIP_DNS_MAX_NAME_LENGTH
#endif
#ifdef CONFIG_LWIP_DNS_MAX_SERVERS
  #define DNS_MAX_SERVERS CONFIG_LWIP_DNS_MAX_SERVERS
#endif
#ifdef CONFIG_LWIP_DNS_MAX_RETRIES
  #define DNS_MAX_RETRIES CONFIG_LWIP_DNS_MAX_RETRIES
#endif
#ifdef CONFIG_LWIP_DNS_DOES_NAME_CHECK
  #define DNS_DOES_NAME_CHECK CONFIG_LWIP_DNS_DOES_NAME_CHECK
#endif
#ifdef CONFIG_LWIP_LWIP_DNS_SECURE
  #define LWIP_DNS_SECURE CONFIG_LWIP_LWIP_DNS_SECURE
#endif
#ifdef CONFIG_LWIP_DNS_LOCAL_HOSTLIST
  #define DNS_LOCAL_HOSTLIST CONFIG_LWIP_DNS_LOCAL_HOSTLIST
#endif
#ifdef CONFIG_LWIP_DNS_LOCAL_HOSTLIST_IS_DYNAMIC
  #define DNS_LOCAL_HOSTLIST_IS_DYNAMIC CONFIG_LWIP_DNS_LOCAL_HOSTLIST_IS_DYNAMIC
#endif
#ifdef CONFIG_LWIP_LWIP_DNS_SUPPORT_MDNS_QUERIES
  #define LWIP_DNS_SUPPORT_MDNS_QUERIES CONFIG_LWIP_LWIP_DNS_SUPPORT_MDNS_QUERIES
#endif

/***   UDP options   ***/
#ifdef CONFIG_LWIP_LWIP_UDP
  #define LWIP_UDP CONFIG_LWIP_LWIP_UDP
#endif
#ifdef CONFIG_LWIP_LWIP_UDPLITE
  #define LWIP_UDPLITE CONFIG_LWIP_LWIP_UDPLITE
#endif
#ifdef CONFIG_LWIP_UDP_TTL
  #define UDP_TTL CONFIG_LWIP_UDP_TTL
#endif
#ifdef CONFIG_LWIP_LWIP_NETBUF_RECVINFO
  #define LWIP_NETBUF_RECVINFO CONFIG_LWIP_LWIP_NETBUF_RECVINFO
#endif

/***   TCP options   ***/
#ifdef CONFIG_LWIP_LWIP_TCP
  #define LWIP_TCP CONFIG_LWIP_LWIP_TCP
#endif
#ifdef CONFIG_LWIP_TCP_TTL
  #define TCP_TTL CONFIG_LWIP_TCP_TTL
#endif
#ifdef CONFIG_LWIP_TCP_WND
  #define TCP_WND CONFIG_LWIP_TCP_WND
#endif
#ifdef CONFIG_LWIP_TCP_MAXRTX
  #define TCP_MAXRTX CONFIG_LWIP_TCP_MAXRTX
#endif
#ifdef CONFIG_LWIP_TCP_SYNMAXRTX
  #define TCP_SYNMAXRTX CONFIG_LWIP_TCP_SYNMAXRTX
#endif
#ifdef CONFIG_LWIP_TCP_QUEUE_OOSEQ
  #define TCP_QUEUE_OOSEQ CONFIG_LWIP_TCP_QUEUE_OOSEQ
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_SACK_OUT
#define LWIP_TCP_SACK_OUT CONFIG_LWIP_LWIP_TCP_SACK_OUT
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_MAX_SACK_NUM
#define LWIP_TCP_MAX_SACK_NUM CONFIG_LWIP_LWIP_TCP_MAX_SACK_NUM
#endif

#ifdef CONFIG_LWIP_TCP_MSS
  #define TCP_MSS CONFIG_LWIP_TCP_MSS
#endif
#ifdef CONFIG_LWIP_TCP_CALCULATE_EFF_SEND_MSS
  #define TCP_CALCULATE_EFF_SEND_MSS CONFIG_LWIP_TCP_CALCULATE_EFF_SEND_MSS
#endif
#ifdef CONFIG_LWIP_TCP_SND_BUF
  #define TCP_SND_BUF CONFIG_LWIP_TCP_SND_BUF
#endif
#ifdef CONFIG_LWIP_TCP_SND_QUEUELEN
  #define TCP_SND_QUEUELEN CONFIG_LWIP_TCP_SND_QUEUELEN
#endif
#ifdef CONFIG_LWIP_TCP_SNDLOWAT
  #define TCP_SNDLOWAT CONFIG_LWIP_TCP_SNDLOWAT
#endif
#ifdef CONFIG_LWIP_TCP_SNDQUEUELOWAT
  #define TCP_SNDQUEUELOWAT CONFIG_LWIP_TCP_SNDQUEUELOWAT
#endif
#ifdef CONFIG_LWIP_TCP_OOSEQ_MAX_BYTES
  #define TCP_OOSEQ_MAX_BYTES CONFIG_LWIP_TCP_OOSEQ_MAX_BYTES
#endif
#ifdef CONFIG_LWIP_TCP_OOSEQ_MAX_PBUFS
  #define TCP_OOSEQ_MAX_PBUFS CONFIG_LWIP_TCP_OOSEQ_MAX_PBUFS
#endif
#ifdef CONFIG_LWIP_TCP_LISTEN_BACKLOG
  #define TCP_LISTEN_BACKLOG CONFIG_LWIP_TCP_LISTEN_BACKLOG
#endif
#ifdef CONFIG_LWIP_TCP_DEFAULT_LISTEN_BACKLOG
  #define TCP_DEFAULT_LISTEN_BACKLOG CONFIG_LWIP_TCP_DEFAULT_LISTEN_BACKLOG
#endif
#ifdef CONFIG_LWIP_TCP_OVERSIZE
  #define TCP_OVERSIZE CONFIG_LWIP_TCP_OVERSIZE
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_TIMESTAMPS
  #define LWIP_TCP_TIMESTAMPS CONFIG_LWIP_LWIP_TCP_TIMESTAMPS
#endif
#ifdef CONFIG_LWIP_TCP_WND_UPDATE_THRESHOLD
  #define TCP_WND_UPDATE_THRESHOLD CONFIG_LWIP_TCP_WND_UPDATE_THRESHOLD
#endif
#ifdef CONFIG_LWIP_LWIP_EVENT_API
  #define LWIP_EVENT_API CONFIG_LWIP_LWIP_EVENT_API
#endif
#ifdef CONFIG_LWIP_LWIP_CALLBACK_API
  #define LWIP_CALLBACK_API CONFIG_LWIP_LWIP_CALLBACK_API
#endif
#ifdef CONFIG_LWIP_LWIP_WND_SCALE
  #define LWIP_WND_SCALE CONFIG_LWIP_LWIP_WND_SCALE
#endif
#ifdef CONFIG_LWIP_TCP_RCV_SCALE
  #define TCP_RCV_SCALE CONFIG_LWIP_TCP_RCV_SCALE
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_PCB_NUM_EXT_ARGS
  #define LWIP_TCP_PCB_NUM_EXT_ARGS CONFIG_LWIP_LWIP_TCP_PCB_NUM_EXT_ARGS
#endif
#ifdef CONFIG_LWIP_LWIP_ALTCP
  #define LWIP_ALTCP CONFIG_LWIP_LWIP_ALTCP
#endif
#ifdef CONFIG_LWIP_LWIP_ALTCP_TLS
  #define LWIP_ALTCP_TLS CONFIG_LWIP_LWIP_ALTCP_TLS
#endif

/***   Pbuf options   ***/
#ifdef CONFIG_LWIP_PBUF_LINK_HLEN
  #define PBUF_LINK_HLEN CONFIG_LWIP_PBUF_LINK_HLEN
#endif
#ifdef CONFIG_LWIP_PBUF_LINK_ENCAPSULATION_HLEN
  #define PBUF_LINK_ENCAPSULATION_HLEN CONFIG_LWIP_PBUF_LINK_ENCAPSULATION_HLEN
#endif
#ifdef CONFIG_LWIP_PBUF_POOL_BUFSIZE
  #define PBUF_POOL_BUFSIZE CONFIG_LWIP_PBUF_POOL_BUFSIZE
#endif
#ifdef CONFIG_LWIP_LWIP_PBUF_REF_T
  #define LWIP_PBUF_REF_T CONFIG_LWIP_LWIP_PBUF_REF_T
#endif

/***   Network Interfaces options   ***/
#ifdef CONFIG_LWIP_LWIP_SINGLE_NETIF
  #define LWIP_SINGLE_NETIF CONFIG_LWIP_LWIP_SINGLE_NETIF
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_HOSTNAME
  #define LWIP_NETIF_HOSTNAME CONFIG_LWIP_LWIP_NETIF_HOSTNAME
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_API
  #define LWIP_NETIF_API CONFIG_LWIP_LWIP_NETIF_API
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_STATUS_CALLBACK
  #define LWIP_NETIF_STATUS_CALLBACK CONFIG_LWIP_LWIP_NETIF_STATUS_CALLBACK
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_EXT_STATUS_CALLBACK
  #define LWIP_NETIF_EXT_STATUS_CALLBACK CONFIG_LWIP_LWIP_NETIF_EXT_STATUS_CALLBACK
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_LINK_CALLBACK
  #define LWIP_NETIF_LINK_CALLBACK CONFIG_LWIP_LWIP_NETIF_LINK_CALLBACK
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_REMOVE_CALLBACK
  #define LWIP_NETIF_REMOVE_CALLBACK CONFIG_LWIP_LWIP_NETIF_REMOVE_CALLBACK
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_HWADDRHINT
  #define LWIP_NETIF_HWADDRHINT CONFIG_LWIP_LWIP_NETIF_HWADDRHINT
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_TX_SINGLE_PBUF
  #define LWIP_NETIF_TX_SINGLE_PBUF CONFIG_LWIP_LWIP_NETIF_TX_SINGLE_PBUF
#endif
#ifdef CONFIG_LWIP_LWIP_NUM_NETIF_CLIENT_DATA
  #define LWIP_NUM_NETIF_CLIENT_DATA CONFIG_LWIP_LWIP_NUM_NETIF_CLIENT_DATA
#endif
/***   LOOPIF options   ***/
#ifdef CONFIG_LWIP_LWIP_HAVE_LOOPIF
  #define LWIP_HAVE_LOOPIF CONFIG_LWIP_LWIP_HAVE_LOOPIF
#endif
#ifdef CONFIG_LWIP_LWIP_LOOPIF_MULTICAST
  #define LWIP_LOOPIF_MULTICAST CONFIG_LWIP_LWIP_LOOPIF_MULTICAST
#endif
/***   LOOPBACK options   ***/
#ifdef CONFIG_LWIP_LWIP_NETIF_LOOPBACK
  #define LWIP_NETIF_LOOPBACK CONFIG_LWIP_LWIP_NETIF_LOOPBACK
#endif
#ifdef CONFIG_LWIP_LWIP_LOOPBACK_MAX_PBUFS
  #define LWIP_LOOPBACK_MAX_PBUFS CONFIG_LWIP_LWIP_LOOPBACK_MAX_PBUFS
#endif
#ifdef CONFIG_LWIP_LWIP_NETIF_LOOPBACK_MULTITHREADING
  #define LWIP_NETIF_LOOPBACK_MULTITHREADING CONFIG_LWIP_LWIP_NETIF_LOOPBACK_MULTITHREADING
#endif

/***   Thread options   ***/
#ifdef CONFIG_LWIP_TCPIP_THREAD_NAME
  #define TCPIP_THREAD_NAME CONFIG_LWIP_TCPIP_THREAD_NAME
#endif
#ifdef CONFIG_LWIP_TCPIP_THREAD_STACKSIZE
  #define TCPIP_THREAD_STACKSIZE CONFIG_LWIP_TCPIP_THREAD_STACKSIZE
#endif
#ifdef CONFIG_LWIP_TCPIP_THREAD_PRIO
  #define TCPIP_THREAD_PRIO CONFIG_LWIP_TCPIP_THREAD_PRIO
#endif
#ifdef CONFIG_LWIP_TCPIP_MBOX_SIZE
  #define TCPIP_MBOX_SIZE CONFIG_LWIP_TCPIP_MBOX_SIZE
#endif
#ifdef CONFIG_LWIP_LWIP_TCPIP_THREAD_ALIVE
  #define LWIP_TCPIP_THREAD_ALIVE CONFIG_LWIP_LWIP_TCPIP_THREAD_ALIVE
#endif
#ifdef CONFIG_LWIP_SLIPIF_THREAD_NAME
  #define SLIPIF_THREAD_NAME CONFIG_LWIP_SLIPIF_THREAD_NAME
#endif
#ifdef CONFIG_LWIP_SLIPIF_THREAD_STACKSIZE
  #define SLIPIF_THREAD_STACKSIZE CONFIG_LWIP_SLIPIF_THREAD_STACKSIZE
#endif
#ifdef CONFIG_LWIP_SLIPIF_THREAD_PRIO
  #define SLIPIF_THREAD_PRIO CONFIG_LWIP_SLIPIF_THREAD_PRIO
#endif
#ifdef CONFIG_LWIP_DEFAULT_THREAD_NAME
  #define DEFAULT_THREAD_NAME CONFIG_LWIP_DEFAULT_THREAD_NAME
#endif
#ifdef CONFIG_LWIP_DEFAULT_THREAD_STACKSIZE
  #define DEFAULT_THREAD_STACKSIZE CONFIG_LWIP_DEFAULT_THREAD_STACKSIZE
#endif
#ifdef CONFIG_LWIP_DEFAULT_THREAD_PRIO
  #define DEFAULT_THREAD_PRIO CONFIG_LWIP_DEFAULT_THREAD_PRIO
#endif
#ifdef CONFIG_LWIP_DEFAULT_RAW_RECVMBOX_SIZE
  #define DEFAULT_RAW_RECVMBOX_SIZE CONFIG_LWIP_DEFAULT_RAW_RECVMBOX_SIZE
#endif
#ifdef CONFIG_LWIP_DEFAULT_UDP_RECVMBOX_SIZE
  #define DEFAULT_UDP_RECVMBOX_SIZE CONFIG_LWIP_DEFAULT_UDP_RECVMBOX_SIZE
#endif
#ifdef CONFIG_LWIP_DEFAULT_TCP_RECVMBOX_SIZE
  #define DEFAULT_TCP_RECVMBOX_SIZE CONFIG_LWIP_DEFAULT_TCP_RECVMBOX_SIZE
#endif
#ifdef CONFIG_LWIP_DEFAULT_ACCEPTMBOX_SIZE
  #define DEFAULT_ACCEPTMBOX_SIZE CONFIG_LWIP_DEFAULT_ACCEPTMBOX_SIZE
#endif

/***   Sequential layer options   ***/
#ifdef CONFIG_LWIP_LWIP_NETCONN
  #define LWIP_NETCONN CONFIG_LWIP_LWIP_NETCONN
#endif
#ifdef CONFIG_LWIP_LWIP_TCPIP_TIMEOUT
  #define LWIP_TCPIP_TIMEOUT CONFIG_LWIP_LWIP_TCPIP_TIMEOUT
#endif
#ifdef CONFIG_LWIP_LWIP_NETCONN_SEM_PER_THREAD
  #define LWIP_NETCONN_SEM_PER_THREAD CONFIG_LWIP_LWIP_NETCONN_SEM_PER_THREAD
#endif
#ifdef CONFIG_LWIP_LWIP_NETCONN_FULLDUPLEX
  #define LWIP_NETCONN_FULLDUPLEX CONFIG_LWIP_LWIP_NETCONN_FULLDUPLEX
#endif

/***   Socket options   ***/
#ifdef CONFIG_LWIP_LWIP_SOCKET
  #define LWIP_SOCKET CONFIG_LWIP_LWIP_SOCKET
#endif
#ifdef CONFIG_LWIP_LWIP_COMPAT_SOCKETS
  #define LWIP_COMPAT_SOCKETS CONFIG_LWIP_LWIP_COMPAT_SOCKETS
#endif
#ifdef CONFIG_LWIP_LWIP_POSIX_SOCKETS_IO_NAMES
  #define LWIP_POSIX_SOCKETS_IO_NAMES CONFIG_LWIP_LWIP_POSIX_SOCKETS_IO_NAMES
#endif
#ifdef CONFIG_LWIP_LWIP_SOCKET_OFFSET
  #define LWIP_SOCKET_OFFSET CONFIG_LWIP_LWIP_SOCKET_OFFSET
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_KEEPALIVE
  #define LWIP_TCP_KEEPALIVE CONFIG_LWIP_LWIP_TCP_KEEPALIVE
#endif
#ifdef CONFIG_LWIP_LWIP_SO_SNDTIMEO
  #define LWIP_SO_SNDTIMEO CONFIG_LWIP_LWIP_SO_SNDTIMEO
#endif
#ifdef CONFIG_LWIP_LWIP_SO_RCVTIMEO
  #define LWIP_SO_RCVTIMEO CONFIG_LWIP_LWIP_SO_RCVTIMEO
#endif
#ifdef CONFIG_LWIP_LWIP_SO_SNDRCVTIMEO_NONSTANDARD
  #define LWIP_SO_SNDRCVTIMEO_NONSTANDARD CONFIG_LWIP_LWIP_SO_SNDRCVTIMEO_NONSTANDARD
#endif
#ifdef CONFIG_LWIP_LWIP_SO_RCVBUF
  #define LWIP_SO_RCVBUF CONFIG_LWIP_LWIP_SO_RCVBUF
#endif
#ifdef CONFIG_LWIP_LWIP_SO_LINGER
  #define LWIP_SO_LINGER CONFIG_LWIP_LWIP_SO_LINGER
#endif
#ifdef CONFIG_LWIP_RECV_BUFSIZE_DEFAULT
  #define RECV_BUFSIZE_DEFAULT CONFIG_LWIP_RECV_BUFSIZE_DEFAULT
#endif
#ifdef CONFIG_LWIP_LWIP_TCP_CLOSE_TIMEOUT_MS_DEFAULT
  #define LWIP_TCP_CLOSE_TIMEOUT_MS_DEFAULT CONFIG_LWIP_LWIP_TCP_CLOSE_TIMEOUT_MS_DEFAULT
#endif
#ifdef CONFIG_LWIP_SO_REUSE
  #define SO_REUSE CONFIG_LWIP_SO_REUSE
#endif
#ifdef CONFIG_LWIP_SO_REUSE_RXTOALL
  #define SO_REUSE_RXTOALL CONFIG_LWIP_SO_REUSE_RXTOALL
#endif
#ifdef CONFIG_LWIP_LWIP_FIONREAD_LINUXMODE
  #define LWIP_FIONREAD_LINUXMODE CONFIG_LWIP_LWIP_FIONREAD_LINUXMODE
#endif
#ifdef CONFIG_LWIP_LWIP_SOCKET_SELECT
  #define LWIP_SOCKET_SELECT CONFIG_LWIP_LWIP_SOCKET_SELECT
#endif
#ifdef CONFIG_LWIP_LWIP_SOCKET_POLL
  #define LWIP_SOCKET_POLL CONFIG_LWIP_LWIP_SOCKET_POLL
#endif

/***   Statistics options   ***/
#ifdef CONFIG_LWIP_LWIP_STATS
  #define LWIP_STATS CONFIG_LWIP_LWIP_STATS
#endif
#ifdef CONFIG_LWIP_LWIP_STATS_DISPLAY
  #define LWIP_STATS_DISPLAY CONFIG_LWIP_LWIP_STATS_DISPLAY
#endif
#ifdef CONFIG_LWIP_LINK_STATS
  #define LINK_STATS CONFIG_LWIP_LINK_STATS
#endif
#ifdef CONFIG_LWIP_ETHARP_STATS
  #define ETHARP_STATS CONFIG_LWIP_ETHARP_STATS
#endif
#ifdef CONFIG_LWIP_IP_STATS
  #define IP_STATS CONFIG_LWIP_IP_STATS
#endif
#ifdef CONFIG_LWIP_IPFRAG_STATS
  #define IPFRAG_STATS CONFIG_LWIP_IPFRAG_STATS
#endif
#ifdef CONFIG_LWIP_ICMP_STATS
  #define ICMP_STATS CONFIG_LWIP_ICMP_STATS
#endif
#ifdef CONFIG_LWIP_IGMP_STATS
  #define IGMP_STATS CONFIG_LWIP_IGMP_STATS
#endif
#ifdef CONFIG_LWIP_UDP_STATS
  #define UDP_STATS CONFIG_LWIP_UDP_STATS
#endif
#ifdef CONFIG_LWIP_TCP_STATS
  #define TCP_STATS CONFIG_LWIP_TCP_STATS
#endif
#ifdef CONFIG_LWIP_MEM_STATS
  #define MEM_STATS CONFIG_LWIP_MEM_STATS
#endif
#ifdef CONFIG_LWIP_MEMP_STATS
  #define MEMP_STATS CONFIG_LWIP_MEMP_STATS
#endif
#ifdef CONFIG_LWIP_SYS_STATS
  #define SYS_STATS CONFIG_LWIP_SYS_STATS
#endif
#ifdef CONFIG_LWIP_IP6_STATS
  #define IP6_STATS CONFIG_LWIP_IP6_STATS
#endif
#ifdef CONFIG_LWIP_ICMP6_STATS
  #define ICMP6_STATS CONFIG_LWIP_ICMP6_STATS
#endif
#ifdef CONFIG_LWIP_IP6_FRAG_STATS
  #define IP6_FRAG_STATS CONFIG_LWIP_IP6_FRAG_STATS
#endif
#ifdef CONFIG_LWIP_MLD6_STATS
  #define MLD6_STATS CONFIG_LWIP_MLD6_STATS
#endif
#ifdef CONFIG_LWIP_ND6_STATS
  #define ND6_STATS CONFIG_LWIP_ND6_STATS
#endif
#ifdef CONFIG_LWIP_MIB2_STATS
#define MIB2_STATS CONFIG_LWIP_MIB2_STATS
#endif

/***   Checksum options   ***/
#ifdef CONFIG_LWIP_LWIP_CHECKSUM_CTRL_PER_NETIF
#define LWIP_CHECKSUM_CTRL_PER_NETIF CONFIG_LWIP_LWIP_CHECKSUM_CTRL_PER_NETIF
#endif
#ifdef CONFIG_LWIP_CHECKSUM_GEN_IP
  #define CHECKSUM_GEN_IP CONFIG_LWIP_CHECKSUM_GEN_IP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_GEN_UDP
  #define CHECKSUM_GEN_UDP CONFIG_LWIP_CHECKSUM_GEN_UDP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_GEN_TCP
  #define CHECKSUM_GEN_TCP CONFIG_LWIP_CHECKSUM_GEN_TCP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_GEN_ICMP
  #define CHECKSUM_GEN_ICMP CONFIG_LWIP_CHECKSUM_GEN_ICMP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_GEN_ICMP6
  #define CHECKSUM_GEN_ICMP6 CONFIG_LWIP_CHECKSUM_GEN_ICMP6
#endif
#ifdef CONFIG_LWIP_CHECKSUM_CHECK_IP
  #define CHECKSUM_CHECK_IP CONFIG_LWIP_CHECKSUM_CHECK_IP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_CHECK_UDP
  #define CHECKSUM_CHECK_UDP CONFIG_LWIP_CHECKSUM_CHECK_UDP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_CHECK_TCP
  #define CHECKSUM_CHECK_TCP CONFIG_LWIP_CHECKSUM_CHECK_TCP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_CHECK_ICMP
  #define CHECKSUM_CHECK_ICMP CONFIG_LWIP_CHECKSUM_CHECK_ICMP
#endif
#ifdef CONFIG_LWIP_CHECKSUM_CHECK_ICMP6
  #define CHECKSUM_CHECK_ICMP6 CONFIG_LWIP_CHECKSUM_CHECK_ICMP6
#endif
#ifdef CONFIG_LWIP_LWIP_CHECKSUM_ON_COPY
  #define LWIP_CHECKSUM_ON_COPY CONFIG_LWIP_LWIP_CHECKSUM_ON_COPY
#endif

/***   PPP options   ***/
#ifdef CONFIG_LWIP_PPP_SUPPORT
  #define PPP_SUPPORT CONFIG_LWIP_PPP_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPPOE_SUPPORT
  #define PPPOE_SUPPORT CONFIG_LWIP_PPPOE_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPPOL2TP_SUPPORT
  #define PPPOL2TP_SUPPORT CONFIG_LWIP_PPPOL2TP_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPPOL2TP_AUTH_SUPPORT
  #define PPPOL2TP_AUTH_SUPPORT CONFIG_LWIP_PPPOL2TP_AUTH_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPPOS_SUPPORT
  #define PPPOS_SUPPORT CONFIG_LWIP_PPPOS_SUPPORT
#endif
#ifdef CONFIG_LWIP_LWIP_PPP_API
  #define LWIP_PPP_API CONFIG_LWIP_LWIP_PPP_API
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_PPP_PCB
  #define MEMP_NUM_PPP_PCB CONFIG_LWIP_MEMP_NUM_PPP_PCB
#endif
#ifdef CONFIG_LWIP_PPP_NUM_TIMEOUTS_PER_PCB
#define PPP_NUM_TIMEOUTS_PER_PCB CONFIG_LWIP_PPP_NUM_TIMEOUTS_PER_PCB
#endif
#ifdef CONFIG_LWIP_PPP_NUM_TIMEOUTS
#define PPP_NUM_TIMEOUTS CONFIG_LWIP_PPP_NUM_TIMEOUTS
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_PPPOS_INTERFACES
  #define MEMP_NUM_PPPOS_INTERFACES CONFIG_LWIP_MEMP_NUM_PPPOS_INTERFACES
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_PPPOE_INTERFACES
  #define MEMP_NUM_PPPOE_INTERFACES CONFIG_LWIP_MEMP_NUM_PPPOE_INTERFACES
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_PPPOL2TP_INTERFACES
  #define MEMP_NUM_PPPOL2TP_INTERFACES CONFIG_LWIP_MEMP_NUM_PPPOL2TP_INTERFACES
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_PPP_API_MSG
#define MEMP_NUM_PPP_API_MSG CONFIG_LWIP_MEMP_NUM_PPP_API_MSG
#endif
#ifdef CONFIG_LWIP_PPP_DEBUG
  #define PPP_DEBUG CONFIG_LWIP_PPP_DEBUG
#endif
#ifdef CONFIG_LWIP_PPP_INPROC_IRQ_SAFE
  #define PPP_INPROC_IRQ_SAFE CONFIG_LWIP_PPP_INPROC_IRQ_SAFE
#endif
#ifdef CONFIG_LWIP_PRINTPKT_SUPPORT
  #define PRINTPKT_SUPPORT CONFIG_LWIP_PRINTPKT_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPP_IPV4_SUPPORT
  #define PPP_IPV4_SUPPORT CONFIG_LWIP_PPP_IPV4_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPP_IPV6_SUPPORT
  #define PPP_IPV6_SUPPORT CONFIG_LWIP_PPP_IPV6_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPP_NOTIFY_PHASE
  #define PPP_NOTIFY_PHASE CONFIG_LWIP_PPP_NOTIFY_PHASE
#endif
#ifdef CONFIG_LWIP_PPP_USE_PBUF_RAM
  #define PPP_USE_PBUF_RAM CONFIG_LWIP_PPP_USE_PBUF_RAM
#endif
#ifdef CONFIG_LWIP_PPP_FCS_TABLE
  #define PPP_FCS_TABLE CONFIG_LWIP_PPP_FCS_TABLE
#endif
#ifdef CONFIG_LWIP_PAP_SUPPORT
  #define PAP_SUPPORT CONFIG_LWIP_PAP_SUPPORT
#endif
#ifdef CONFIG_LWIP_CHAP_SUPPORT
  #define CHAP_SUPPORT CONFIG_LWIP_CHAP_SUPPORT
#endif
#ifdef CONFIG_LWIP_MSCHAP_SUPPORT
  #define MSCHAP_SUPPORT CONFIG_LWIP_MSCHAP_SUPPORT
#endif
#ifdef CONFIG_LWIP_EAP_SUPPORT
  #define EAP_SUPPORT CONFIG_LWIP_EAP_SUPPORT
#endif
#ifdef CONFIG_LWIP_CCP_SUPPORT
  #define CCP_SUPPORT CONFIG_LWIP_CCP_SUPPORT
#endif
#ifdef CONFIG_LWIP_MPPE_SUPPORT
  #define MPPE_SUPPORT CONFIG_LWIP_MPPE_SUPPORT
#endif
#ifdef CONFIG_LWIP_CBCP_SUPPORT
  #define CBCP_SUPPORT CONFIG_LWIP_CBCP_SUPPORT
#endif
#ifdef CONFIG_LWIP_ECP_SUPPORT
  #define ECP_SUPPORT CONFIG_LWIP_ECP_SUPPORT
#endif
#ifdef CONFIG_LWIP_DEMAND_SUPPORT
  #define DEMAND_SUPPORT CONFIG_LWIP_DEMAND_SUPPORT
#endif
#ifdef CONFIG_LWIP_LQR_SUPPORT
  #define LQR_SUPPORT CONFIG_LWIP_LQR_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPP_SERVER
  #define PPP_SERVER CONFIG_LWIP_PPP_SERVER
#endif
#ifdef CONFIG_LWIP_PPP_OUR_NAME
  #define PPP_OUR_NAME CONFIG_LWIP_PPP_OUR_NAME
#endif
#ifdef CONFIG_LWIP_VJ_SUPPORT
  #define VJ_SUPPORT CONFIG_LWIP_VJ_SUPPORT
#endif
#ifdef CONFIG_LWIP_PPP_MD5_RANDM
  #define PPP_MD5_RANDM CONFIG_LWIP_PPP_MD5_RANDM
#endif
#ifdef CONFIG_LWIP_LWIP_USE_EXTERNAL_POLARSSL
#define LWIP_USE_EXTERNAL_POLARSSL CONFIG_LWIP_LWIP_USE_EXTERNAL_POLARSSL
#endif
#ifdef CONFIG_LWIP_LWIP_USE_EXTERNAL_MBEDTLS
#define LWIP_USE_EXTERNAL_MBEDTLS CONFIG_LWIP_LWIP_USE_EXTERNAL_MBEDTLS
#endif
#ifdef CONFIG_LWIP_FSM_DEFTIMEOUT
  #define FSM_DEFTIMEOUT CONFIG_LWIP_FSM_DEFTIMEOUT
#endif
#ifdef CONFIG_LWIP_FSM_DEFMAXTERMREQS
  #define FSM_DEFMAXTERMREQS CONFIG_LWIP_FSM_DEFMAXTERMREQS
#endif
#ifdef CONFIG_LWIP_FSM_DEFMAXCONFREQS
  #define FSM_DEFMAXCONFREQS CONFIG_LWIP_FSM_DEFMAXCONFREQS
#endif
#ifdef CONFIG_LWIP_FSM_DEFMAXNAKLOOPS
  #define FSM_DEFMAXNAKLOOPS CONFIG_LWIP_FSM_DEFMAXNAKLOOPS
#endif
#ifdef CONFIG_LWIP_UPAP_DEFTIMEOUT
  #define UPAP_DEFTIMEOUT CONFIG_LWIP_UPAP_DEFTIMEOUT
#endif
#ifdef CONFIG_LWIP_UPAP_DEFTRANSMITS
  #define UPAP_DEFTRANSMITS CONFIG_LWIP_UPAP_DEFTRANSMITS
#endif
#ifdef CONFIG_LWIP_UPAP_DEFREQTIME
  #define UPAP_DEFREQTIME CONFIG_LWIP_UPAP_DEFREQTIME
#endif
#ifdef CONFIG_LWIP_CHAP_DEFTIMEOUT
  #define CHAP_DEFTIMEOUT CONFIG_LWIP_CHAP_DEFTIMEOUT
#endif
#ifdef CONFIG_LWIP_CHAP_DEFTRANSMITS
  #define CHAP_DEFTRANSMITS CONFIG_LWIP_CHAP_DEFTRANSMITS
#endif
#ifdef CONFIG_LWIP_CHAP_DEFRECHALLENGETIME
  #define CHAP_DEFRECHALLENGETIME CONFIG_LWIP_CHAP_DEFRECHALLENGETIME
#endif
#ifdef CONFIG_LWIP_EAP_DEFREQTIME
  #define EAP_DEFREQTIME CONFIG_LWIP_EAP_DEFREQTIME
#endif
#ifdef CONFIG_LWIP_EAP_DEFALLOWREQ
  #define EAP_DEFALLOWREQ CONFIG_LWIP_EAP_DEFALLOWREQ
#endif
#ifdef CONFIG_LWIP_EAP_DEFTIMEOUT
  #define EAP_DEFTIMEOUT CONFIG_LWIP_EAP_DEFTIMEOUT
#endif
#ifdef CONFIG_LWIP_EAP_DEFTRANSMITS
  #define EAP_DEFTRANSMITS CONFIG_LWIP_EAP_DEFTRANSMITS
#endif
#ifdef CONFIG_LWIP_LCP_DEFLOOPBACKFAIL
  #define LCP_DEFLOOPBACKFAIL CONFIG_LWIP_LCP_DEFLOOPBACKFAIL
#endif
#ifdef CONFIG_LWIP_LCP_ECHOINTERVAL
  #define LCP_ECHOINTERVAL CONFIG_LWIP_LCP_ECHOINTERVAL
#endif
#ifdef CONFIG_LWIP_LCP_MAXECHOFAILS
  #define LCP_MAXECHOFAILS CONFIG_LWIP_LCP_MAXECHOFAILS
#endif
#ifdef CONFIG_LWIP_PPP_MAXIDLEFLAG
  #define PPP_MAXIDLEFLAG CONFIG_LWIP_PPP_MAXIDLEFLAG
#endif
#ifdef CONFIG_LWIP_PPP_MRU
  #define PPP_MRU CONFIG_LWIP_PPP_MRU
#endif
#ifdef CONFIG_LWIP_PPP_DEFMRU
  #define PPP_DEFMRU CONFIG_LWIP_PPP_DEFMRU
#endif
#ifdef CONFIG_LWIP_PPP_MAXMRU
  #define PPP_MAXMRU CONFIG_LWIP_PPP_MAXMRU
#endif
#ifdef CONFIG_LWIP_PPP_MINMRU
  #define PPP_MINMRU CONFIG_LWIP_PPP_MINMRU
#endif
#ifdef CONFIG_LWIP_PPPOL2TP_DEFMRU
  #define PPPOL2TP_DEFMRU CONFIG_LWIP_PPPOL2TP_DEFMRU
#endif
#ifdef CONFIG_LWIP_MAXNAMELEN
  #define MAXNAMELEN CONFIG_LWIP_MAXNAMELEN
#endif
#ifdef CONFIG_LWIP_MAXSECRETLEN
  #define MAXSECRETLEN CONFIG_LWIP_MAXSECRETLEN
#endif
#ifdef CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_MD5
  #define LWIP_INCLUDED_POLARSSL_MD5 CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_MD5
#endif
#ifdef CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_MD4
  #define LWIP_INCLUDED_POLARSSL_MD4 CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_MD4
#endif
#ifdef CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_SHA1
  #define LWIP_INCLUDED_POLARSSL_SHA1 CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_SHA1
#endif
#ifdef CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_DES
  #define LWIP_INCLUDED_POLARSSL_DES CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_DES
#endif
#ifdef CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_ARC4
  #define LWIP_INCLUDED_POLARSSL_ARC4 CONFIG_LWIP_LWIP_INCLUDED_POLARSSL_ARC4
#endif

/***   IPv6 options   ***/
#ifdef CONFIG_LWIP_LWIP_IPV6
  #define LWIP_IPV6 CONFIG_LWIP_LWIP_IPV6
#endif
#ifdef CONFIG_LWIP_IPV6_REASS_MAXAGE
  #define IPV6_REASS_MAXAGE CONFIG_LWIP_IPV6_REASS_MAXAGE
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_SCOPES
  #define LWIP_IPV6_SCOPES CONFIG_LWIP_LWIP_IPV6_SCOPES
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_SCOPES_DEBUG
  #define LWIP_IPV6_SCOPES_DEBUG CONFIG_LWIP_LWIP_IPV6_SCOPES_DEBUG
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_NUM_ADDRESSES
  #define LWIP_IPV6_NUM_ADDRESSES CONFIG_LWIP_LWIP_IPV6_NUM_ADDRESSES
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_FORWARD
  #define LWIP_IPV6_FORWARD CONFIG_LWIP_LWIP_IPV6_FORWARD
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_FRAG
  #define LWIP_IPV6_FRAG CONFIG_LWIP_LWIP_IPV6_FRAG
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_REASS
  #define LWIP_IPV6_REASS CONFIG_LWIP_LWIP_IPV6_REASS
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_SEND_ROUTER_SOLICIT
  #define LWIP_IPV6_SEND_ROUTER_SOLICIT CONFIG_LWIP_LWIP_IPV6_SEND_ROUTER_SOLICIT
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_AUTOCONFIG
  #define LWIP_IPV6_AUTOCONFIG CONFIG_LWIP_LWIP_IPV6_AUTOCONFIG
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_ADDRESS_LIFETIMES
  #define LWIP_IPV6_ADDRESS_LIFETIMES CONFIG_LWIP_LWIP_IPV6_ADDRESS_LIFETIMES
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_DUP_DETECT_ATTEMPTS
  #define LWIP_IPV6_DUP_DETECT_ATTEMPTS CONFIG_LWIP_LWIP_IPV6_DUP_DETECT_ATTEMPTS
#endif
#ifdef CONFIG_LWIP_LWIP_ICMP6
  #define LWIP_ICMP6 CONFIG_LWIP_LWIP_ICMP6
#endif
#ifdef CONFIG_LWIP_LWIP_ICMP6_DATASIZE
  #define LWIP_ICMP6_DATASIZE CONFIG_LWIP_LWIP_ICMP6_DATASIZE
#endif
#ifdef CONFIG_LWIP_LWIP_ICMP6_HL
  #define LWIP_ICMP6_HL CONFIG_LWIP_LWIP_ICMP6_HL
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_MLD
  #define LWIP_IPV6_MLD CONFIG_LWIP_LWIP_IPV6_MLD
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_MLD6_GROUP
  #define MEMP_NUM_MLD6_GROUP CONFIG_LWIP_MEMP_NUM_MLD6_GROUP
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_QUEUEING
  #define LWIP_ND6_QUEUEING CONFIG_LWIP_LWIP_ND6_QUEUEING
#endif
#ifdef CONFIG_LWIP_MEMP_NUM_ND6_QUEUE
  #define MEMP_NUM_ND6_QUEUE CONFIG_LWIP_MEMP_NUM_ND6_QUEUE
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_NUM_NEIGHBORS
  #define LWIP_ND6_NUM_NEIGHBORS CONFIG_LWIP_LWIP_ND6_NUM_NEIGHBORS
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_NUM_DESTINATIONS
  #define LWIP_ND6_NUM_DESTINATIONS CONFIG_LWIP_LWIP_ND6_NUM_DESTINATIONS
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_NUM_PREFIXES
  #define LWIP_ND6_NUM_PREFIXES CONFIG_LWIP_LWIP_ND6_NUM_PREFIXES
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_NUM_ROUTERS
  #define LWIP_ND6_NUM_ROUTERS CONFIG_LWIP_LWIP_ND6_NUM_ROUTERS
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_MAX_MULTICAST_SOLICIT
  #define LWIP_ND6_MAX_MULTICAST_SOLICIT CONFIG_LWIP_LWIP_ND6_MAX_MULTICAST_SOLICIT
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_MAX_UNICAST_SOLICIT
  #define LWIP_ND6_MAX_UNICAST_SOLICIT CONFIG_LWIP_LWIP_ND6_MAX_UNICAST_SOLICIT
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_MAX_ANYCAST_DELAY_TIME
  #define LWIP_ND6_MAX_ANYCAST_DELAY_TIME CONFIG_LWIP_LWIP_ND6_MAX_ANYCAST_DELAY_TIME
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_MAX_NEIGHBOR_ADVERTISEMENT
  #define LWIP_ND6_MAX_NEIGHBOR_ADVERTISEMENT CONFIG_LWIP_LWIP_ND6_MAX_NEIGHBOR_ADVERTISEMENT
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_REACHABLE_TIME
  #define LWIP_ND6_REACHABLE_TIME CONFIG_LWIP_LWIP_ND6_REACHABLE_TIME
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_RETRANS_TIMER
  #define LWIP_ND6_RETRANS_TIMER CONFIG_LWIP_LWIP_ND6_RETRANS_TIMER
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_DELAY_FIRST_PROBE_TIME
  #define LWIP_ND6_DELAY_FIRST_PROBE_TIME CONFIG_LWIP_LWIP_ND6_DELAY_FIRST_PROBE_TIME
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_ALLOW_RA_UPDATES
  #define LWIP_ND6_ALLOW_RA_UPDATES CONFIG_LWIP_LWIP_ND6_ALLOW_RA_UPDATES
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_TCP_REACHABILITY_HINTS
  #define LWIP_ND6_TCP_REACHABILITY_HINTS CONFIG_LWIP_LWIP_ND6_TCP_REACHABILITY_HINTS
#endif
#ifdef CONFIG_LWIP_LWIP_ND6_RDNSS_MAX_DNS_SERVERS
#define LWIP_ND6_RDNSS_MAX_DNS_SERVERS CONFIG_LWIP_LWIP_ND6_RDNSS_MAX_DNS_SERVERS
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_DHCP6
  #define LWIP_IPV6_DHCP6 CONFIG_LWIP_LWIP_IPV6_DHCP6
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_DHCP6_STATEFUL
#define LWIP_IPV6_DHCP6_STATEFUL CONFIG_LWIP_LWIP_IPV6_DHCP6_STATEFUL
#endif
#ifdef CONFIG_LWIP_LWIP_IPV6_DHCP6_STATELESS
#define LWIP_IPV6_DHCP6_STATELESS CONFIG_LWIP_LWIP_IPV6_DHCP6_STATELESS
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP6_GET_NTP_SRV
#define LWIP_DHCP6_GET_NTP_SRV CONFIG_LWIP_LWIP_DHCP6_GET_NTP_SRV
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP6_MAX_NTP_SERVERS
#define LWIP_DHCP6_MAX_NTP_SERVERS CONFIG_LWIP_LWIP_DHCP6_MAX_NTP_SERVERS
#endif
#ifdef CONFIG_LWIP_LWIP_DHCP6_MAX_DNS_SERVERS
#define LWIP_DHCP6_MAX_DNS_SERVERS CONFIG_LWIP_LWIP_DHCP6_MAX_DNS_SERVERS
#endif

/***   Hook options   ***/
#ifdef CONFIG_LWIP_LWIP_HOOK_FILENAME
#define LWIP_HOOK_FILENAME CONFIG_LWIP_LWIP_HOOK_FILENAME
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_TCP_ISN
#define LWIP_HOOK_TCP_ISN CONFIG_LWIP_LWIP_HOOK_TCP_ISN
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_TCP_INPACKET_PCB
#define LWIP_HOOK_TCP_INPACKET_PCB CONFIG_LWIP_LWIP_HOOK_TCP_INPACKET_PCB
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_TCP_OUT_TCPOPT_LENGTH
#define LWIP_HOOK_TCP_OUT_TCPOPT_LENGTH CONFIG_LWIP_LWIP_HOOK_TCP_OUT_TCPOPT_LENGTH
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_TCP_OUT_ADD_TCPOPTS
#define LWIP_HOOK_TCP_OUT_ADD_TCPOPTS CONFIG_LWIP_LWIP_HOOK_TCP_OUT_ADD_TCPOPTS
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP4_INPUT
#define LWIP_HOOK_IP4_INPUT CONFIG_LWIP_LWIP_HOOK_IP4_INPUT
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP4_ROUTE
#define LWIP_HOOK_IP4_ROUTE CONFIG_LWIP_LWIP_HOOK_IP4_ROUTE
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP4_ROUTE_SRC
#define LWIP_HOOK_IP4_ROUTE_SRC CONFIG_LWIP_LWIP_HOOK_IP4_ROUTE_SRC
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP4_CANFORWARD
#define LWIP_HOOK_IP4_CANFORWARD CONFIG_LWIP_LWIP_HOOK_IP4_CANFORWARD
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_ETHARP_GET_GW
#define LWIP_HOOK_ETHARP_GET_GW CONFIG_LWIP_LWIP_HOOK_ETHARP_GET_GW
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP6_INPUT
#define LWIP_HOOK_IP6_INPUT CONFIG_LWIP_LWIP_HOOK_IP6_INPUT
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_IP6_ROUTE
#define LWIP_HOOK_IP6_ROUTE CONFIG_LWIP_LWIP_HOOK_IP6_ROUTE
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_ND6_GET_GW
#define LWIP_HOOK_ND6_GET_GW CONFIG_LWIP_LWIP_HOOK_ND6_GET_GW
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_VLAN_CHECK
#define LWIP_HOOK_VLAN_CHECK CONFIG_LWIP_LWIP_HOOK_VLAN_CHECK
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_VLAN_SET
#define LWIP_HOOK_VLAN_SET CONFIG_LWIP_LWIP_HOOK_VLAN_SET
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_MEMP_AVAILABLE
#define LWIP_HOOK_MEMP_AVAILABLE CONFIG_LWIP_LWIP_HOOK_MEMP_AVAILABLE
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_UNKNOWN_ETH_PROTOCOL
#define LWIP_HOOK_UNKNOWN_ETH_PROTOCOL CONFIG_LWIP_LWIP_HOOK_UNKNOWN_ETH_PROTOCOL
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_DHCP_APPEND_OPTIONS
#define LWIP_HOOK_DHCP_APPEND_OPTIONS CONFIG_LWIP_LWIP_HOOK_DHCP_APPEND_OPTIONS
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_DHCP_PARSE_OPTION
#define LWIP_HOOK_DHCP_PARSE_OPTION CONFIG_LWIP_LWIP_HOOK_DHCP_PARSE_OPTION
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_DHCP6_APPEND_OPTIONS
#define LWIP_HOOK_DHCP6_APPEND_OPTIONS CONFIG_LWIP_LWIP_HOOK_DHCP6_APPEND_OPTIONS
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_SOCKETS_SETSOCKOPT
#define LWIP_HOOK_SOCKETS_SETSOCKOPT CONFIG_LWIP_LWIP_HOOK_SOCKETS_SETSOCKOPT
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_SOCKETS_GETSOCKOPT
#define LWIP_HOOK_SOCKETS_GETSOCKOPT CONFIG_LWIP_LWIP_HOOK_SOCKETS_GETSOCKOPT
#endif
#ifdef CONFIG_LWIP_LWIP_HOOK_NETCONN_EXTERNAL_RESOLVE
#define LWIP_HOOK_NETCONN_EXTERNAL_RESOLVE CONFIG_LWIP_LWIP_HOOK_NETCONN_EXTERNAL_RESOLVE
#endif

/***   Debugging options   ***/
/* - Except CONFIG_LWIP_LWIP_DEBUG, CONFIG_LWIP_LWIP_DBG_MIN_LEVEL,
 *   CONFIG_LWIP_LWIP_DBG_TYPES_ON all other CONFIG_LWIP_<xxxx>_DEBUG
 *   configurations should be defined as ORed combination of LWIP_DBG_<type>
 *   constants (LWIP_DBG_ON, LWIP_DBG_TRACE, LWIP_DBG_STATE, LWIP_DBG_FRESH,
 *   LWIP_DBG_HALT) in config.omk.
 * - CONFIG_LWIP_LWIP_DEBUG enables the whole debug system
 * - CONFIG_LWIP_LWIP_DBG_MIN_LEVEL defines debug level and must be one of the
 *   following constants (LWIP_DBG_LEVEL_ALL, LWIP_DBG_LEVEL_WARNING,
 *   LWIP_DBG_LEVEL_SERIOUS, LWIP_DBG_LEVEL_SEVERE)
 * - CONFIG_LWIP_LWIP_DBG_TYPES_ON is mask which can globally enable/disable
 *   certain types of debug messages, ORed combination of (LWIP_DBG_ON,
 *   LWIP_DBG_TRACE, LWIP_DBG_STATE, LWIP_DBG_FRESH)
 *
 * example in config.omk:
 *  CONFIG_LWIP_LWIP_DEBUG=y
 *  CONFIG_LWIP_NETIF_DEBUG = (LWIP_DBG_ON|LWIP_DBG_STATE)
 *  CONFIG_LWIP_LWIP_DBG_MIN_LEVEL = LWIP_DBG_LEVEL_WARNING
 *
 */
#if CONFIG_LWIP_LWIP_DEBUG
  #define LWIP_DEBUG
#endif

#ifdef CONFIG_LWIP_LWIP_DBG_MIN_LEVEL
  #define LWIP_DBG_MIN_LEVEL CONFIG_LWIP_LWIP_DBG_MIN_LEVEL
#endif
#ifdef CONFIG_LWIP_LWIP_DBG_TYPES_ON
  #define LWIP_DBG_TYPES_ON CONFIG_LWIP_LWIP_DBG_TYPES_ON
#endif
#ifdef CONFIG_LWIP_ETHARP_DEBUG
  #define ETHARP_DEBUG CONFIG_LWIP_ETHARP_DEBUG
#endif
#ifdef CONFIG_LWIP_NETIF_DEBUG
  #define NETIF_DEBUG CONFIG_LWIP_NETIF_DEBUG
#endif
#ifdef CONFIG_LWIP_PBUF_DEBUG
  #define PBUF_DEBUG CONFIG_LWIP_PBUF_DEBUG
#endif
#ifdef CONFIG_LWIP_API_LIB_DEBUG
  #define API_LIB_DEBUG CONFIG_LWIP_API_LIB_DEBUG
#endif
#ifdef CONFIG_LWIP_API_MSG_DEBUG
  #define API_MSG_DEBUG CONFIG_LWIP_API_MSG_DEBUG
#endif
#ifdef CONFIG_LWIP_SOCKETS_DEBUG
  #define SOCKETS_DEBUG CONFIG_LWIP_SOCKETS_DEBUG
#endif
#ifdef CONFIG_LWIP_ICMP_DEBUG
  #define ICMP_DEBUG CONFIG_LWIP_ICMP_DEBUG
#endif
#ifdef CONFIG_LWIP_IGMP_DEBUG
  #define IGMP_DEBUG CONFIG_LWIP_IGMP_DEBUG
#endif
#ifdef CONFIG_LWIP_INET_DEBUG
  #define INET_DEBUG CONFIG_LWIP_INET_DEBUG
#endif
#ifdef CONFIG_LWIP_IP_DEBUG
  #define IP_DEBUG CONFIG_LWIP_IP_DEBUG
#endif
#ifdef CONFIG_LWIP_IP_REASS_DEBUG
  #define IP_REASS_DEBUG CONFIG_LWIP_IP_REASS_DEBUG
#endif
#ifdef CONFIG_LWIP_RAW_DEBUG
  #define RAW_DEBUG CONFIG_LWIP_RAW_DEBUG
#endif
#ifdef CONFIG_LWIP_MEM_DEBUG
  #define MEM_DEBUG CONFIG_LWIP_MEM_DEBUG
#endif
#ifdef CONFIG_LWIP_MEMP_DEBUG
  #define MEMP_DEBUG CONFIG_LWIP_MEMP_DEBUG
#endif
#ifdef CONFIG_LWIP_SYS_DEBUG
  #define SYS_DEBUG CONFIG_LWIP_SYS_DEBUG
#endif
#ifdef CONFIG_LWIP_TIMERS_DEBUG
  #define TIMERS_DEBUG CONFIG_LWIP_TIMERS_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_DEBUG
  #define TCP_DEBUG CONFIG_LWIP_TCP_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_INPUT_DEBUG
  #define TCP_INPUT_DEBUG CONFIG_LWIP_TCP_INPUT_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_FR_DEBUG
  #define TCP_FR_DEBUG CONFIG_LWIP_TCP_FR_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_RTO_DEBUG
  #define TCP_RTO_DEBUG CONFIG_LWIP_TCP_RTO_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_CWND_DEBUG
  #define TCP_CWND_DEBUG CONFIG_LWIP_TCP_CWND_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_WND_DEBUG
  #define TCP_WND_DEBUG CONFIG_LWIP_TCP_WND_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_OUTPUT_DEBUG
  #define TCP_OUTPUT_DEBUG CONFIG_LWIP_TCP_OUTPUT_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_RST_DEBUG
  #define TCP_RST_DEBUG CONFIG_LWIP_TCP_RST_DEBUG
#endif
#ifdef CONFIG_LWIP_TCP_QLEN_DEBUG
  #define TCP_QLEN_DEBUG CONFIG_LWIP_TCP_QLEN_DEBUG
#endif
#ifdef CONFIG_LWIP_UDP_DEBUG
  #define UDP_DEBUG CONFIG_LWIP_UDP_DEBUG
#endif
#ifdef CONFIG_LWIP_TCPIP_DEBUG
  #define TCPIP_DEBUG CONFIG_LWIP_TCPIP_DEBUG
#endif
#ifdef CONFIG_LWIP_SLIP_DEBUG
  #define SLIP_DEBUG CONFIG_LWIP_SLIP_DEBUG
#endif
#ifdef CONFIG_LWIP_DHCP_DEBUG
  #define DHCP_DEBUG CONFIG_LWIP_DHCP_DEBUG
#endif
#ifdef CONFIG_LWIP_AUTOIP_DEBUG
  #define AUTOIP_DEBUG CONFIG_LWIP_AUTOIP_DEBUG
#endif
#ifdef CONFIG_LWIP_DNS_DEBUG
  #define DNS_DEBUG CONFIG_LWIP_DNS_DEBUG
#endif
#ifdef CONFIG_LWIP_IP6_DEBUG
  #define IP6_DEBUG CONFIG_LWIP_IP6_DEBUG
#endif
#ifdef CONFIG_LWIP_DHCP6_DEBUG
  #define DHCP6_DEBUG CONFIG_LWIP_DHCP6_DEBUG
#endif

/***   Performance tracking options   ***/
#ifdef CONFIG_LWIP_LWIP_TESTMODE
  #define LWIP_TESTMODE CONFIG_LWIP_LWIP_TESTMODE
#endif
#ifdef CONFIG_LWIP_LWIP_PERF
  #define LWIP_PERF CONFIG_LWIP_LWIP_PERF
#endif

/* --------------------- Options for LwIP applications  --------------------- */
/***   iPerf server   ***/
#ifdef CONFIG_LWIP_LWIP_APP_IPERF
  #define LWIP_APP_IPERF CONFIG_LWIP_LWIP_APP_IPERF
#endif

/***   HTTP client   ***/
#ifdef CONFIG_LWIP_LWIP_APP_HTTPC
  #define LWIP_APP_HTTPC CONFIG_LWIP_LWIP_APP_HTTPC
#endif

/***   HTTP server   ***/
#ifdef CONFIG_LWIP_LWIP_APP_HTTPD
  #define LWIP_APP_HTTPD CONFIG_LWIP_LWIP_APP_HTTPD
#endif

#ifdef CONFIG_LWIP_LWIP_HTTPD_CGI
  #define LWIP_HTTPD_CGI CONFIG_LWIP_LWIP_HTTPD_CGI
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_CGI_SSI
  #define LWIP_HTTPD_CGI_SSI CONFIG_LWIP_LWIP_HTTPD_CGI_SSI
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SSI
  #define LWIP_HTTPD_SSI CONFIG_LWIP_LWIP_HTTPD_SSI
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SSI_RAW
  #define LWIP_HTTPD_SSI_RAW CONFIG_LWIP_LWIP_HTTPD_SSI_RAW
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SSI_BY_FILE_EXTENSION
  #define LWIP_HTTPD_SSI_BY_FILE_EXTENSION CONFIG_LWIP_LWIP_HTTPD_SSI_BY_FILE_EXTENSION
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SUPPORT_POST
  #define LWIP_HTTPD_SUPPORT_POST CONFIG_LWIP_LWIP_HTTPD_SUPPORT_POST
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_MAX_CGI_PARAMETERS
  #define LWIP_HTTPD_MAX_CGI_PARAMETERS CONFIG_LWIP_LWIP_HTTPD_MAX_CGI_PARAMETERS
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SSI_MULTIPART
  #define LWIP_HTTPD_SSI_MULTIPART CONFIG_LWIP_LWIP_HTTPD_SSI_MULTIPART
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_MAX_TAG_NAME_LEN
  #define LWIP_HTTPD_MAX_TAG_NAME_LEN CONFIG_LWIP_LWIP_HTTPD_MAX_TAG_NAME_LEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_MAX_TAG_INSERT_LEN
  #define LWIP_HTTPD_MAX_TAG_INSERT_LEN CONFIG_LWIP_LWIP_HTTPD_MAX_TAG_INSERT_LEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_POST_MANUAL_WND
  #define LWIP_HTTPD_POST_MANUAL_WND CONFIG_LWIP_LWIP_HTTPD_POST_MANUAL_WND
#endif
#ifdef CONFIG_LWIP_HTTPD_SERVER_AGENT
  #define HTTPD_SERVER_AGENT CONFIG_LWIP_HTTPD_SERVER_AGENT
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_DYNAMIC_HEADERS
  #define LWIP_HTTPD_DYNAMIC_HEADERS CONFIG_LWIP_LWIP_HTTPD_DYNAMIC_HEADERS
#endif
#ifdef CONFIG_LWIP_HTTPD_DEBUG
  #define HTTPD_DEBUG CONFIG_LWIP_HTTPD_DEBUG
#endif
#ifdef CONFIG_LWIP_HTTPD_USE_MEM_POOL
  #define HTTPD_USE_MEM_POOL CONFIG_LWIP_HTTPD_USE_MEM_POOL
#endif
#ifdef CONFIG_LWIP_HTTPD_SERVER_PORT
  #define HTTPD_SERVER_PORT CONFIG_LWIP_HTTPD_SERVER_PORT
#endif
#ifdef CONFIG_LWIP_HTTPD_SERVER_PORT_HTTPS
  #define HTTPD_SERVER_PORT_HTTPS CONFIG_LWIP_HTTPD_SERVER_PORT_HTTPS
#endif
#ifdef CONFIG_LWIP_HTTPD_ENABLE_HTTPS
  #define HTTPD_ENABLE_HTTPS CONFIG_LWIP_HTTPD_ENABLE_HTTPS
#endif
#ifdef CONFIG_LWIP_HTTPD_MAX_RETRIES
  #define HTTPD_MAX_RETRIES CONFIG_LWIP_HTTPD_MAX_RETRIES
#endif
#ifdef CONFIG_LWIP_HTTPD_POLL_INTERVAL
  #define HTTPD_POLL_INTERVAL CONFIG_LWIP_HTTPD_POLL_INTERVAL
#endif
#ifdef CONFIG_LWIP_HTTPD_TCP_PRIO
  #define HTTPD_TCP_PRIO CONFIG_LWIP_HTTPD_TCP_PRIO
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_TIMING
  #define LWIP_HTTPD_TIMING CONFIG_LWIP_LWIP_HTTPD_TIMING
#endif
#ifdef CONFIG_LWIP_HTTPD_DEBUG_TIMING
  #define HTTPD_DEBUG_TIMING CONFIG_LWIP_HTTPD_DEBUG_TIMING
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SUPPORT_EXTSTATUS
  #define LWIP_HTTPD_SUPPORT_EXTSTATUS CONFIG_LWIP_LWIP_HTTPD_SUPPORT_EXTSTATUS
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SUPPORT_V09
  #define LWIP_HTTPD_SUPPORT_V09 CONFIG_LWIP_LWIP_HTTPD_SUPPORT_V09
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SUPPORT_11_KEEPALIVE
  #define LWIP_HTTPD_SUPPORT_11_KEEPALIVE CONFIG_LWIP_LWIP_HTTPD_SUPPORT_11_KEEPALIVE
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SUPPORT_REQUESTLIST
  #define LWIP_HTTPD_SUPPORT_REQUESTLIST CONFIG_LWIP_LWIP_HTTPD_SUPPORT_REQUESTLIST
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_REQ_QUEUELEN
  #define LWIP_HTTPD_REQ_QUEUELEN CONFIG_LWIP_LWIP_HTTPD_REQ_QUEUELEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_REQ_BUFSIZE
  #define LWIP_HTTPD_REQ_BUFSIZE CONFIG_LWIP_LWIP_HTTPD_REQ_BUFSIZE
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_MAX_REQ_LENGTH
  #define LWIP_HTTPD_MAX_REQ_LENGTH CONFIG_LWIP_LWIP_HTTPD_MAX_REQ_LENGTH
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_MAX_REQUEST_URI_LEN
  #define LWIP_HTTPD_MAX_REQUEST_URI_LEN CONFIG_LWIP_LWIP_HTTPD_MAX_REQUEST_URI_LEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_POST_MAX_RESPONSE_URI_LEN
  #define LWIP_HTTPD_POST_MAX_RESPONSE_URI_LEN CONFIG_LWIP_LWIP_HTTPD_POST_MAX_RESPONSE_URI_LEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_SSI_INCLUDE_TAG
  #define LWIP_HTTPD_SSI_INCLUDE_TAG CONFIG_LWIP_LWIP_HTTPD_SSI_INCLUDE_TAG
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_ABORT_ON_CLOSE_MEM_ERROR
  #define LWIP_HTTPD_ABORT_ON_CLOSE_MEM_ERROR CONFIG_LWIP_LWIP_HTTPD_ABORT_ON_CLOSE_MEM_ERROR
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_KILL_OLD_ON_CONNECTIONS_EXCEEDED
  #define LWIP_HTTPD_KILL_OLD_ON_CONNECTIONS_EXCEEDED CONFIG_LWIP_LWIP_HTTPD_KILL_OLD_ON_CONNECTIONS_EXCEEDED
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_OMIT_HEADER_FOR_EXTENSIONLESS_URI
  #define LWIP_HTTPD_OMIT_HEADER_FOR_EXTENSIONLESS_URI CONFIG_LWIP_LWIP_HTTPD_OMIT_HEADER_FOR_EXTENSIONLESS_URI
#endif
#ifdef CONFIG_LWIP_HTTP_IS_TAG_VOLATILE
  #define HTTP_IS_TAG_VOLATILE CONFIG_LWIP_HTTP_IS_TAG_VOLATILE
#endif
#ifdef CONFIG_LWIP_HTTPD_LIMIT_SENDING_TO_2MSS
  #define HTTPD_LIMIT_SENDING_TO_2MSS CONFIG_LWIP_HTTPD_LIMIT_SENDING_TO_2MSS
#endif
#ifdef CONFIG_LWIP_HTTPD_MAX_WRITE_LEN
  #define HTTPD_MAX_WRITE_LEN CONFIG_LWIP_HTTPD_MAX_WRITE_LEN
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_CUSTOM_FILES
  #define LWIP_HTTPD_CUSTOM_FILES CONFIG_LWIP_LWIP_HTTPD_CUSTOM_FILES
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_DYNAMIC_FILE_READ
  #define LWIP_HTTPD_DYNAMIC_FILE_READ CONFIG_LWIP_LWIP_HTTPD_DYNAMIC_FILE_READ
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_FILE_STATE
  #define LWIP_HTTPD_FILE_STATE CONFIG_LWIP_LWIP_HTTPD_FILE_STATE
#endif
#ifdef CONFIG_LWIP_HTTPD_PRECALCULATED_CHECKSUM
  #define HTTPD_PRECALCULATED_CHECKSUM CONFIG_LWIP_HTTPD_PRECALCULATED_CHECKSUM
#endif
#ifdef CONFIG_LWIP_LWIP_HTTPD_FS_ASYNC_READ
  #define LWIP_HTTPD_FS_ASYNC_READ CONFIG_LWIP_LWIP_HTTPD_FS_ASYNC_READ
#endif
#ifdef CONFIG_LWIP_HTTPD_FSDATA_FILE
  #define HTTPD_FSDATA_FILE CONFIG_LWIP_HTTPD_FSDATA_FILE
#endif



/***   SNMP options   ***/
#ifdef CONFIG_LWIP_LWIP_SNMP
  #define LWIP_SNMP CONFIG_LWIP_LWIP_SNMP
#endif
#ifdef CONFIG_LWIP_SNMP_USE_NETCONN
#define SNMP_USE_NETCONN CONFIG_LWIP_SNMP_USE_NETCONN
#endif
#ifdef CONFIG_LWIP_SNMP_USE_RAW
#define SNMP_USE_RAW CONFIG_LWIP_SNMP_USE_RAW
#endif
#ifdef CONFIG_LWIP_SNMP_STACK_SIZE
#define SNMP_STACK_SIZE CONFIG_LWIP_SNMP_STACK_SIZE
#endif
#ifdef CONFIG_LWIP_SNMP_THREAD_PRIO
#define SNMP_THREAD_PRIO CONFIG_LWIP_SNMP_THREAD_PRIO
#endif
#ifdef CONFIG_LWIP_SNMP_TRAP_DESTINATIONS
  #define SNMP_TRAP_DESTINATIONS CONFIG_LWIP_SNMP_TRAP_DESTINATIONS
#endif
#ifdef CONFIG_LWIP_SNMP_SAFE_REQUESTS
  #define SNMP_SAFE_REQUESTS CONFIG_LWIP_SNMP_SAFE_REQUESTS
#endif
#ifdef CONFIG_LWIP_SNMP_MAX_OCTET_STRING_LEN
  #define SNMP_MAX_OCTET_STRING_LEN CONFIG_LWIP_SNMP_MAX_OCTET_STRING_LEN
#endif
#ifdef CONFIG_LWIP_SNMP_MAX_OBJ_ID_LEN
#define SNMP_MAX_OBJ_ID_LEN CONFIG_LWIP_SNMP_MAX_OBJ_ID_LEN
#endif
#ifdef CONFIG_LWIP_SNMP_MIN_VALUE_SIZE
#define SNMP_MIN_VALUE_SIZE CONFIG_LWIP_SNMP_MIN_VALUE_SIZE
#endif
#ifdef CONFIG_LWIP_SNMP_MAX_VALUE_SIZE
  #define SNMP_MAX_VALUE_SIZE CONFIG_LWIP_SNMP_MAX_VALUE_SIZE
#endif
#ifdef CONFIG_LWIP_SNMP_COMMUNITY
  #define SNMP_COMMUNITY CONFIG_LWIP_SNMP_COMMUNITY
#endif
#ifdef CONFIG_LWIP_SNMP_COMMUNITY_WRITE
  #define SNMP_COMMUNITY_WRITE CONFIG_LWIP_SNMP_COMMUNITY_WRITE
#endif
#ifdef CONFIG_LWIP_SNMP_COMMUNITY_TRAP
  #define SNMP_COMMUNITY_TRAP CONFIG_LWIP_SNMP_COMMUNITY_TRAP
#endif
#ifdef CONFIG_LWIP_SNMP_MAX_COMMUNITY_STR_LEN
#define SNMP_MAX_COMMUNITY_STR_LEN CONFIG_LWIP_SNMP_MAX_COMMUNITY_STR_LEN
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_ENTERPRISE_OID
#define SNMP_LWIP_ENTERPRISE_OID CONFIG_LWIP_SNMP_LWIP_ENTERPRISE_OID
#endif
#ifdef CONFIG_LWIP_SNMP_DEVICE_ENTERPRISE_OID
#define SNMP_DEVICE_ENTERPRISE_OID CONFIG_LWIP_SNMP_DEVICE_ENTERPRISE_OID
#endif
#ifdef CONFIG_LWIP_SNMP_DEVICE_ENTERPRISE_OID_LEN
#define SNMP_DEVICE_ENTERPRISE_OID_LEN CONFIG_LWIP_SNMP_DEVICE_ENTERPRISE_OID_LEN
#endif
#ifdef CONFIG_LWIP_SNMP_DEBUG
#define SNMP_DEBUG CONFIG_LWIP_SNMP_DEBUG
#endif
#ifdef CONFIG_LWIP_SNMP_MIB_DEBUG
  #define SNMP_MIB_DEBUG CONFIG_LWIP_SNMP_MIB_DEBUG
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_MIB2
#define SNMP_LWIP_MIB2 CONFIG_LWIP_SNMP_LWIP_MIB2
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_MIB2_SYSDESC
#define SNMP_LWIP_MIB2_SYSDESC CONFIG_LWIP_SNMP_LWIP_MIB2_SYSDESC
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_MIB2_SYSNAME
#define SNMP_LWIP_MIB2_SYSNAME CONFIG_LWIP_SNMP_LWIP_MIB2_SYSNAME
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_MIB2_SYSCONTACT
#define SNMP_LWIP_MIB2_SYSCONTACT CONFIG_LWIP_SNMP_LWIP_MIB2_SYSCONTACT
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_MIB2_SYSLOCATION
#define SNMP_LWIP_MIB2_SYSLOCATION CONFIG_LWIP_SNMP_LWIP_MIB2_SYSLOCATION
#endif
#ifdef CONFIG_LWIP_SNMP_LWIP_GETBULK_MAX_REPETITIONS
#define SNMP_LWIP_GETBULK_MAX_REPETITIONS CONFIG_LWIP_SNMP_LWIP_GETBULK_MAX_REPETITIONS
#endif
#ifdef CONFIG_LWIP_LWIP_SNMP_V3
#define LWIP_SNMP_V3 CONFIG_LWIP_LWIP_SNMP_V3
#endif
#ifdef CONFIG_LWIP_LWIP_SNMP_V3_MBEDTLS
#define LWIP_SNMP_V3_MBEDTLS CONFIG_LWIP_LWIP_SNMP_V3_MBEDTLS
#endif
#ifdef CONFIG_LWIP_LWIP_SNMP_V3_CRYPTO
#define LWIP_SNMP_V3_CRYPTO CONFIG_LWIP_LWIP_SNMP_V3_CRYPTO
#endif
#ifdef CONFIG_LWIP_LWIP_SNMP_CONFIGURE_VERSIONS
#define LWIP_SNMP_CONFIGURE_VERSIONS CONFIG_LWIP_LWIP_SNMP_CONFIGURE_VERSIONS
#endif


/***   APPS: MQTT client ***/
#ifdef CONFIG_LWIP_LWIP_APP_MQTT
#define LWIP_APP_MQTT CONFIG_LWIP_LWIP_APP_MQTT
#endif
#ifdef CONFIG_LWIP_MQTT_OUTPUT_RINGBUF_SIZE
#define MQTT_OUTPUT_RINGBUF_SIZE CONFIG_LWIP_MQTT_OUTPUT_RINGBUF_SIZE
#endif
#ifdef CONFIG_LWIP_MQTT_VAR_HEADER_BUFFER_LEN
#define MQTT_VAR_HEADER_BUFFER_LEN CONFIG_LWIP_MQTT_VAR_HEADER_BUFFER_LEN
#endif
#ifdef CONFIG_LWIP_MQTT_REQ_MAX_IN_FLIGHT
#define MQTT_REQ_MAX_IN_FLIGHT CONFIG_LWIP_MQTT_REQ_MAX_IN_FLIGHT
#endif
#ifdef CONFIG_LWIP_MQTT_CYCLIC_TIMER_INTERVAL
#define MQTT_CYCLIC_TIMER_INTERVAL CONFIG_LWIP_MQTT_CYCLIC_TIMER_INTERVAL
#endif
#ifdef CONFIG_LWIP_MQTT_REQ_TIMEOUT
#define MQTT_REQ_TIMEOUT CONFIG_LWIP_MQTT_REQ_TIMEOUT
#endif
#ifdef CONFIG_LWIP_MQTT_CONNECT_TIMOUT
#define MQTT_CONNECT_TIMOUT CONFIG_LWIP_MQTT_CONNECT_TIMOUT
#endif

/***   APPS: TFTP server ***/
#ifdef CONFIG_LWIP_LWIP_APP_TFTP
#define LWIP_APP_TFTP CONFIG_LWIP_LWIP_APP_TFTP
#endif
#ifdef CONFIG_LWIP_TFTP_DEBUG
#define TFTP_DEBUG CONFIG_LWIP_TFTP_DEBUG
#endif
#ifdef CONFIG_LWIP_TFTP_PORT
#define TFTP_PORT CONFIG_LWIP_TFTP_PORT
#endif
#ifdef CONFIG_LWIP_TFTP_TIMEOUT_MSECS
#define TFTP_TIMEOUT_MSECS CONFIG_LWIP_TFTP_TIMEOUT_MSECS
#endif
#ifdef CONFIG_LWIP_TFTP_MAX_RETRIES
#define TFTP_MAX_RETRIES CONFIG_LWIP_TFTP_MAX_RETRIES
#endif
#ifdef CONFIG_LWIP_TFTP_TIMER_MSECS
#define TFTP_TIMER_MSECS CONFIG_LWIP_TFTP_TIMER_MSECS
#endif
#ifdef CONFIG_LWIP_TFTP_MAX_FILENAME_LEN
#define TFTP_MAX_FILENAME_LEN CONFIG_LWIP_TFTP_MAX_FILENAME_LEN
#endif
#ifdef CONFIG_LWIP_TFTP_MAX_MODE_LEN
#define TFTP_MAX_MODE_LEN CONFIG_LWIP_TFTP_MAX_MODE_LEN
#endif

/***   APPS: MDNS responder ***/
#ifdef CONFIG_LWIP_LWIP_MDNS_RESPONDER
#define LWIP_MDNS_RESPONDER CONFIG_LWIP_LWIP_MDNS_RESPONDER
#endif
#ifdef CONFIG_LWIP_MDNS_MAX_SERVICES
#define MDNS_MAX_SERVICES CONFIG_LWIP_MDNS_MAX_SERVICES
#endif
#ifdef CONFIG_LWIP_MDNS_RESP_USENETIF_EXTCALLBACK
#define MDNS_RESP_USENETIF_EXTCALLBACK CONFIG_LWIP_MDNS_RESP_USENETIF_EXTCALLBACK
#endif
#ifdef CONFIG_LWIP_MDNS_DEBUG
#define MDNS_DEBUG CONFIG_LWIP_MDNS_DEBUG
#endif

/***   APPS: SNTP client ***/
#ifdef CONFIG_LWIP_LWIP_APP_SNTP
#define LWIP_APP_SNTP CONFIG_LWIP_LWIP_APP_SNTP
#endif
#ifdef CONFIG_LWIP_SNTP_SET_SYSTEM_TIME
#define SNTP_SET_SYSTEM_TIME CONFIG_LWIP_SNTP_SET_SYSTEM_TIME
#endif
#ifdef CONFIG_LWIP_SNTP_MAX_SERVERS
#define SNTP_MAX_SERVERS CONFIG_LWIP_SNTP_MAX_SERVERS
#endif
#ifdef CONFIG_LWIP_SNTP_GET_SERVERS_FROM_DHCP
#define SNTP_GET_SERVERS_FROM_DHCP CONFIG_LWIP_SNTP_GET_SERVERS_FROM_DHCP
#endif
#ifdef CONFIG_LWIP_SNTP_SERVER_ADDRESS
#define SNTP_SERVER_ADDRESS CONFIG_LWIP_SNTP_SERVER_ADDRESS
#endif
#ifdef CONFIG_LWIP_SNTP_SERVER_DNS
#define SNTP_SERVER_DNS CONFIG_LWIP_SNTP_SERVER_DNS
#endif
#ifdef CONFIG_LWIP_SNTP_DEBUG
#define SNTP_DEBUG CONFIG_LWIP_SNTP_DEBUG
#endif
#ifdef CONFIG_LWIP_SNTP_PORT
#define SNTP_PORT CONFIG_LWIP_SNTP_PORT
#endif
#ifdef CONFIG_LWIP_SNTP_CHECK_RESPONSE
#define SNTP_CHECK_RESPONSE CONFIG_LWIP_SNTP_CHECK_RESPONSE
#endif
#ifdef CONFIG_LWIP_SNTP_COMP_ROUNDTRIP
#define SNTP_COMP_ROUNDTRIP CONFIG_LWIP_SNTP_COMP_ROUNDTRIP
#endif
#ifdef CONFIG_LWIP_SNTP_STARTUP_DELAY
#define SNTP_STARTUP_DELAY CONFIG_LWIP_SNTP_STARTUP_DELAY
#endif
#ifdef CONFIG_LWIP_SNTP_STARTUP_DELAY
#define SNTP_STARTUP_DELAY CONFIG_LWIP_SNTP_STARTUP_DELAY
#endif
#ifdef CONFIG_LWIP_SNTP_STARTUP_DELAY_FUNC
#define SNTP_STARTUP_DELAY_FUNC CONFIG_LWIP_SNTP_STARTUP_DELAY_FUNC
#endif
#ifdef CONFIG_LWIP_SNTP_RECV_TIMEOUT
#define SNTP_RECV_TIMEOUT CONFIG_LWIP_SNTP_RECV_TIMEOUT
#endif
#ifdef CONFIG_LWIP_SNTP_UPDATE_DELAY
#define SNTP_UPDATE_DELAY CONFIG_LWIP_SNTP_UPDATE_DELAY
#endif
#ifdef CONFIG_LWIP_SNTP_GET_SYSTEM_TIME
#define SNTP_GET_SYSTEM_TIME CONFIG_LWIP_SNTP_GET_SYSTEM_TIME
#endif
#ifdef CONFIG_LWIP_SNTP_RETRY_TIMEOUT
#define SNTP_RETRY_TIMEOUT CONFIG_LWIP_SNTP_RETRY_TIMEOUT
#endif
#ifdef CONFIG_LWIP_SNTP_RETRY_TIMEOUT_MAX
#define SNTP_RETRY_TIMEOUT_MAX CONFIG_LWIP_SNTP_RETRY_TIMEOUT_MAX
#endif
#ifdef CONFIG_LWIP_SNTP_RETRY_TIMEOUT_EXP
#define SNTP_RETRY_TIMEOUT_EXP CONFIG_LWIP_SNTP_RETRY_TIMEOUT_EXP
#endif
#ifdef CONFIG_LWIP_SNTP_MONITOR_SERVER_REACHABILITY
#define SNTP_MONITOR_SERVER_REACHABILITY CONFIG_LWIP_SNTP_MONITOR_SERVER_REACHABILITY
#endif

/***   APPS: Application Layered TCP/TLS connection API ***/
#ifdef CONFIG_LWIP_LWIP_ALTCP_TLS_MBEDTLS
#define LWIP_ALTCP_TLS_MBEDTLS CONFIG_LWIP_LWIP_ALTCP_TLS_MBEDTLS
#endif
#ifdef CONFIG_LWIP_ALTCP_MBEDTLS_DEBUG
#define ALTCP_MBEDTLS_DEBUG CONFIG_LWIP_ALTCP_MBEDTLS_DEBUG
#endif
#ifdef CONFIG_LWIP_ALTCP_MBEDTLS_SESSION_CACHE_TIMEOUT_SECONDS
#define ALTCP_MBEDTLS_SESSION_CACHE_TIMEOUT_SECONDS CONFIG_LWIP_ALTCP_MBEDTLS_SESSION_CACHE_TIMEOUT_SECONDS
#endif

/*** APPS: SMTP client module ***/
#ifdef CONFIG_LWIP_LWIP_APP_SMTP
#define LWIP_APP_SMTP CONFIG_LWIP_LWIP_APP_SMTP
#endif
#ifdef CONFIG_LWIP_SMTP_BODYDH
#define SMTP_BODYDH CONFIG_LWIP_SMTP_BODYDH
#endif
#ifdef CONFIG_LWIP_SMTP_DEBUG
#define SMTP_DEBUG CONFIG_LWIP_SMTP_DEBUG
#endif
#ifdef CONFIG_LWIP_SMTP_MAX_SERVERNAME_LEN
#define SMTP_MAX_SERVERNAME_LEN  CONFIG_LWIP_SMTP_MAX_SERVERNAME_LEN
#endif
#ifdef CONFIG_LWIP_SMTP_MAX_USERNAME_LEN
#define SMTP_MAX_USERNAME_LEN CONFIG_LWIP_SMTP_MAX_USERNAME_LEN
#endif
#ifdef CONFIG_LWIP_SMTP_MAX_PASS_LEN
#define SMTP_MAX_PASS_LEN CONFIG_LWIP_SMTP_MAX_PASS_LEN
#endif
#ifdef CONFIG_LWIP_SMTP_COPY_AUTHDATA
#define SMTP_COPY_AUTHDATA  CONFIG_LWIP_SMTP_COPY_AUTHDATA
#endif
#ifdef CONFIG_LWIP_SMTP_CHECK_DATA
#define SMTP_CHECK_DATA CONFIG_LWIP_SMTP_CHECK_DATA
#endif
#ifdef CONFIG_LWIP_SMTP_SUPPORT_AUTH_PLAIN
#define SMTP_SUPPORT_AUTH_PLAIN CONFIG_LWIP_SMTP_SUPPORT_AUTH_PLAIN
#endif
#ifdef CONFIG_LWIP_SMTP_SUPPORT_AUTH_LOGIN
#define SMTP_SUPPORT_AUTH_LOGIN CONFIG_LWIP_SMTP_SUPPORT_AUTH_LOGIN
#endif
#ifdef CONFIG_LWIP_SMTP_STATE_MALLOC
#define SMTP_STATE_MALLOC CONFIG_LWIP_SMTP_STATE_MALLOC
#endif
#ifdef CONFIG_LWIP_SMTP_STATE_FREE
#define SMTP_STATE_FREE CONFIG_LWIP_SMTP_STATE_FREE
#endif

/*** APPS: NetBIOS name service responder ***/
#ifdef CONFIG_LWIP_LWIP_APP_NETBIOSNS
#define LWIP_APP_NETBIOSNS CONFIG_LWIP_LWIP_APP_NETBIOSNS
#endif
#ifdef CONFIG_LWIP_NETBIOS_LWIP_NAME
#define NETBIOS_LWIP_NAME CONFIG_LWIP_NETBIOS_LWIP_NAME
#endif
#ifdef CONFIG_LWIP_LWIP_NETBIOS_RESPOND_NAME_QUERY
#define LWIP_NETBIOS_RESPOND_NAME_QUERY CONFIG_LWIP_LWIP_NETBIOS_RESPOND_NAME_QUERY
#endif


/* -------------------------------------------------------------------------- */
/* DEFAULT VALUES if not defined in OMK and we want them different from lwip/opt.h */
/* Prevent having to link sys_arch.c (we don't test the API layers in unit tests) */
#ifndef LWIP_TIMEVAL_PRIVATE
  #define LWIP_TIMEVAL_PRIVATE 0
#endif

#ifndef NO_SYS
  #define NO_SYS        1
#endif

#ifndef SYS_LIGHTWEIGHT_PROT
  #define SYS_LIGHTWEIGHT_PROT  0
#endif

#ifndef LWIP_NETCONN
  #define LWIP_NETCONN  0
#endif

#ifndef LWIP_SOCKET
  #define LWIP_SOCKET   0
#endif

#ifndef LWIP_STATS
  #define LWIP_STATS      0
#endif

#ifndef MEM_ALIGNMENT
  #define MEM_ALIGNMENT   2
#endif

#ifndef CONFIG_LWIP_WITHOUT_FREE
  #define CONFIG_LWIP_WITHOUT_FREE 0
#endif

#endif /* LWIPOPTS_CONNECTION_TO_OMK_CONFIGURATION_HEADER_FILE */
